#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cassert>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    string S;
    cin >> S;
    int N = S.size();

    vector<int> rad(N + 1);
    vector<vector<int>> foldr(N + 1), foldl(N + 1);
    int far = 0;
    for (int i = 1; i <= N; i++)
    {
        int r = 0;
        if (i < far + rad[far])
            r = min(rad[2 * far - i], far + rad[far] - i);
        while (r < i && i + r < N && S[i - r - 1] == S[i + r])
            r++;
        rad[i] = r;
        assert(i + r <= N);
        if (i + r > far + rad[far])
            far = i;

        foldl[i - r].push_back(i);
        foldr[i + r].push_back(i);
    }

    int L = 0;
    int R = N;
    while (true)
    {
        int oldL = L;
        int oldR = R;

        int dL = L;
        while (dL <= L)
        {
            for (int v : foldl[dL])
                if (2 * v <= L + R)
                    L = max(L, v);
            dL++;
        }
        int dR = R;
        while (dR >= R)
        {
            for (int v : foldr[dR])
                if (2 * v >= L + R)
                    R = min(R, v);
            dR--;
        }
        if (oldL == L && oldR == R)
            break;
    }
    cout << R - L << '\n';
}
