#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

vector<int> manacher(string s) {
    int n = s.size();
    vector<int> d2 (n);
    int l=0, r=-1;
    for (int i=0; i<n; ++i) {
        int k = (i>r ? 0 : min (d2[l+r-i+1], r-i+1)) + 1;
        while (i+k-1 < n && i-k >= 0 && s[i+k-1] == s[i-k])  ++k;
        d2[i] = --k;
        if (i+k-1 > r)
            l = i-k,  r = i+k-1;
    }

    return d2;
}

int main() {
    string S; cin >> S;
    int N = S.size();
    
    vector<vector<bool>> F(2);
    for (int i = 0; i < 2; ++i) {
        vector<int> Longest = manacher(S);
        F[i].assign(N, false);
        F[i][0] = true;
        int best = 0;
        for (int j = 1; j < N; ++j) if (best >= j - Longest[j]) { best = j; F[i][j] = true; }        
        if (!i) reverse(S.begin(),S.end());
    }

    reverse(F[1].begin(),F[1].end());
    int ans = N;
    int j = 0;
    for (int i = 0; i < N-1; ++i) {
        if (F[0][i]) {
            j = max(i, j);
            while (!F[1][j]) ++j;
            ans = min(ans, j-i+1);
        }
    }

    cout << ans << endl;
}
