#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <utility>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <queue>
using namespace std;

typedef long double ld;
typedef long long ll;

#define MAX 4000000

char str1[MAX + 2];
char str2[MAX + 2];

int N;
int pallen[MAX + 2];

int fold_phase(char *s) {
  int furthest = 0;
  pallen[0] = 0;
  int beg = 0;
  for (int i = 1; i <= N; i++) {  // fold is between i-1 and i
    int to_check = i;
    if (furthest + pallen[furthest] > i) {
      if (i + pallen[2 * furthest - i] < furthest + pallen[furthest]) {
        pallen[i] = pallen[2 * furthest - i];
        if (i - pallen[i] <= beg) {
          beg = i;
        }
        continue;
      } else {
        to_check = furthest + pallen[furthest];
      }
    }
    while (true) {
      if (2 * i - to_check - 1 < beg) {
        pallen[i] = to_check - i;
        furthest = i;
        beg = i;
        break;
      }
     if (to_check >= N || s[to_check] != s[2 * i - to_check - 1]) {
        pallen[i] = to_check - i;
        break;
      }
      to_check += 1;
    }
    if (i + pallen[i] > furthest + pallen[furthest]) {
      furthest = i;
    }
    // fprintf(stderr, "For fold point %d pallen is %d, beg is %d, furthest %d\n", 
    //        i, pallen[i], beg, furthest);
  }
  return beg;
}

int main() {
  scanf("%s", str1);
  N = strlen(str1);
  fprintf(stderr, "Folding forward, N = %d\n", N);
  int beg = fold_phase(str1);
  fprintf(stderr, "Cutpoint obtained: %d\n", beg);
  int i = N - 1;
  N = 0;
  for (; i >= beg; i--) {
    str2[N++] = str1[i];
  }
  fprintf(stderr, "Folding backward, N = %d\n", N);
  beg = fold_phase(str2);
  fprintf(stderr, "Cutpoint obtained: %d\n", beg);
  printf("%d\n", N - beg);
  return 0;
}
