#!/usr/bin/env python3

MOD = 1000000000000037
B = 257

S = list(map(ord, input()))
n = len(S)

FHash = [0]*(n+1)
BHash = [0]*(n+1)
BPow = [1]*(n+1)
for i in range(n):
    FHash[i+1] = (FHash[i]*B + S[i]) % MOD
    BPow[i+1] = (BPow[i]*B) % MOD
for i in range(n-1, -1, -1):
    BHash[i] = (BHash[i+1]*B + S[i]) % MOD

def is_palin(l, r):
    return (FHash[r] - BPow[r-l]*FHash[l]) % MOD == (BHash[l] - BPow[r-l]*BHash[r]) % MOD

l = 0
r = n
i = 1
while i <= (r-l)//2:
    if is_palin(l, l+2*i):
        l += i
        i = 1
    elif is_palin(r-2*i, r):
        r -= i
        i = 1
    else:
        i += 1

print(r-l)

