/* Does a linear-time check in each palindrome test */

#include <iostream>
#include <string>
#include <algorithm>
#include <cstring>

using namespace std;

static bool is_palindrome(const string &S, const string &Sr, int L, int R)
{
    return memcmp(S.data() + L, Sr.data() + (S.size() - R), (R - L) / 2) == 0;
}

int main()
{
    ios::sync_with_stdio(false);
    string S;
    cin >> S;
    int L = 0, R = S.size();
    string Sr = S;
    reverse(Sr.begin(), Sr.end());
    bool more = true;
    while (more)
    {
        more = false;
        for (int i = 2; i <= R - L; i += 2)
        {
            if (is_palindrome(S, Sr, L, L + i))
            {
                L += i / 2;
                more = true;
                break;
            }
            else if (is_palindrome(S, Sr, R - i, R))
            {
                R -= i / 2;
                more = true;
                break;
            }
        }
    }
    cout << R - L << '\n';
    return 0;
}
