/* Checks for any possible right fold before considering left folds. */

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cassert>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    string S;
    cin >> S;
    int N = S.size();

    vector<int> rad(N + 1);
    int far = 0;
    for (int i = 1; i <= N; i++)
    {
        int r = 0;
        if (i < far + rad[far])
            r = min(rad[2 * far - i], far + rad[far] - i);
        while (r < i && i + r < N && S[i - r - 1] == S[i + r])
            r++;
        rad[i] = r;
        assert(i + r <= N);
        if (i + r > far + rad[far])
            far = i;
    }

    int L = 0;
    int R = N;
    while (true)
    {
        for (int i = R - 1; 2 * i >= L + R; i--)
            if (rad[i] >= R - i)
            {
                R = i;
                goto found;
            }
        for (int i = L + 1; 2 * i <= L + R; i++)
            if (rad[i] >= i - L)
            {
                L = i;
                goto found;
            }
        break;
found:;
    }

    cout << R - L << '\n';
}
