
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

/**
 * ICPC World Finals 2020
 * Problem Solution: Landscape
 * 
 * @author Martin Kacer
 */
public class LandscapeMK {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() {
		while (!st.hasMoreTokens()) try {
			String line = input.readLine();
			if (line == null) return false;
			st = new StringTokenizer(line);
		} catch (Exception ex) { throw new RuntimeException(ex); }
		return true;
	}
	String nextToken() {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	public static void main(String[] args) throws Exception {
		new LandscapeMK().run();
	}
	
	int[] p;

	void run() {
		int n = nextInt(), k = nextInt();
		p = new int[n];
		while (k-- > 0) {
			char op = nextToken().charAt(0);
			int x = nextInt() - 1, y = nextInt() + 1;
			switch (op) {
			case 'H': hill(x, y, +1); break;
			case 'V': hill(x, y, -1); break;
			case 'R': hill(x, y, +1); hill(x+1, y-1, -1); break;
			case 'D': hill(x, y, -1); hill(x+1, y-1, +1); break;
			}
		}
		long c = 0, h = 0;
		for (int d : p) {
			c += d;
			h += c;
			System.out.println(h);
		}
	}
	
	void hill(int x, int y, int s) {
		inc(x, s);
		inc((x+y)/2, -s);
		inc((x+y+1)/2, -s);
		inc(y, s);
	}
	void inc(int i, int s) {
		if (i < p.length) p[i] += s;
	}
}
