#include <iostream>

using namespace std;

typedef long long ll;

const ll maxn = 1<<18;

ll ost[2][maxn * 2];

void insert1(ll ix, ll f, ll t, ll x, ll a, ll b) {
  if (f == x) {
    ost[0][ix] += a;
    ost[1][ix] += b;
  } else {
    ll m = (f + t) / 2;
    if (x <= m) {
      ost[0][ix * 2 + 1] += a;
      ost[1][ix * 2 + 1] += b;
      insert1(ix * 2, f, m, x, a, b);
    } else
      insert1(ix * 2 + 1, m + 1, t, x, a, b);
  }
}

void insert2(ll x1, ll x2, ll a, ll b) {
  if (x1 <= x2) {
    insert1(1, 1, maxn, x1, a, b);
    insert1(1, 1, maxn, x2 + 1, -a, -b);
  }
}

ll get1(ll ix, ll f, ll t, ll x) {
  ll v = 0;
  while (f <= x && x <= t) {
    v += ost[0][ix] * x + ost[1][ix];
    ll m = (f + t) / 2;
    if (x <= m) {
      ix = ix * 2;
      t = min(m, t - 1);
    } else {
      ix = ix * 2 + 1;
      f = m + 1;
    }
  }
  return v;
}

ll get2(ll x) {
  return get1(1, 1, maxn, x);
}

int main() {
  for (int i = 0; i < maxn * 2; i++)
    ost[0][i] = ost[1][i] = 0;
  ll n, k;
  cin >> n >> k;
  for (ll i = 0; i < k; i++) {
    char op;
    ll x1, x2;
    cin >> ws >> op >> x1 >> x2;
    if (op == 'R')
      insert2(x1, x2, 0, 1);
    else if (op == 'D')
      insert2(x1, x2, 0, -1);
    else {
      ll xm = (x2 + x1) / 2;
      if (op == 'H') {
        insert2(x1, xm, 1, 1 - x1);
        insert2(xm + 1, x2, -1, x2 + 1);
      } else {
        insert2(x1, xm, -1, x1 - 1);
        insert2(xm + 1, x2, 1, -x2 - 1);
      }
    }
  }
  for (ll i = 1; i <= n; i++)
    cout << get2(i) << endl;
  return 0;
}

