#!/usr/bin/env python3

import sys

maxn = 2**18

ost = [ [0]*(maxn*2) for _ in range(2) ]

def insert1(ix, f, t, x, a, b):
  if f == x:
    ost[0][ix] += a
    ost[1][ix] += b
  else:
    m = (f + t) // 2
    if x <= m:
      ost[0][ix * 2 + 1] += a
      ost[1][ix * 2 + 1] += b
      insert1(ix * 2, f, m, x, a, b)
    else:
      insert1(ix * 2 + 1, m + 1, t, x, a, b)

def insert2(x1, x2, a, b):
  if x1 <= x2:
    insert1(1, 1, maxn, x1, a, b)
    insert1(1, 1, maxn, x2 + 1, -a, -b)

def get1(ix, f, t, x):
  v = 0
  while f <= x <= t:
    v += ost[0][ix] * x + ost[1][ix]
    m = (f + t) // 2
    if x <= m:
      ix = ix * 2
      t = min(m, t - 1)
    else:
      ix = ix * 2 + 1
      f = m + 1
  return v

def get2(x):
  return get1(1, 1, maxn, x)

n, k = map(int, sys.stdin.readline().split())
for _ in range(k):
  op, x1, x2 = sys.stdin.readline().split()
  x1 = int(x1)
  x2 = int(x2)
  if op == 'R':
    insert2(x1, x2, 0, 1)
  elif op == 'D':
    insert2(x1, x2, 0, -1)
  else:
    xm = (x2 + x1) // 2
    if op == 'H':
      insert2(x1, xm, 1, 1 - x1)
      insert2(xm + 1, x2, -1, x2 + 1)
    else:
      insert2(x1, xm, -1, x1 - 1)
      insert2(xm + 1, x2, 1, -x2 - 1)
for i in range(1, n+1):
  print(get2(i))

