import random
import sys

file_cnt = 0
def next_file0(desc = None):
  global file_cnt
  file_cnt += 1
  if desc != None:
    file_name = "{:02}.desc".format(file_cnt)
    sys.stdout.close()
    sys.stdout = open(file_name, "w")
    print(desc)
  file_name = "{:02}.in".format(file_cnt)
  sys.stdout.close()
  sys.stdout = open(file_name, "w")

def next_file(n, k, s):
  next_file0('n = {}, k = {}: {}'.format(n, k, s))

random.seed(314159265)

minn, maxn = 1, 2*10**5
mink, maxk = 0, 2*10**5
OPS = "RDHV"
COPS = "DRVH"

try:
  xrange
except:
  xrange = range

def print_ops(ops):
  for c, x1, x2 in ops:
    print('{} {} {}'.format(c, x1, x2))

def print_case(ops, n=None):
  k = len(ops)
  if n == None:
    n = max(x2 for _, _, x2 in ops) if k > 0 else minn
  print("{} {}".format(n, k))
  print_ops(ops)

def random_input(n, k):
  ops = []
  for _ in range(k):
    i = random.randrange(len(OPS))
    c = OPS[i]
    x1 = random.randint(1, n)
    x2 = random.randint(1, n)
    ops.append((c, min(x1, x2), max(x1, x2)))
  print_case(ops, n)

def small_random(q):
  for _ in range(q):
    n = random.randint(minn, 100)
    k = random.randint(mink, 100)
    next_file(n, k, 'random')
    random_input(n, k)

def med_random(q):
  for _ in range(q):
    n = random.randint(100, maxn // 100)
    k = random.randint(mink, 100)
    next_file(n, k, 'random')
    random_input(n, k)
  for _ in range(q):
    n = random.randint(minn, 100)
    k = random.randint(100, maxk // 100)
    next_file(n, k, 'random')
    random_input(n, k)
  for _ in range(q):
    n = random.randint(100, maxn // 100)
    k = random.randint(100, maxk // 100)
    next_file(n, k, 'random')
    random_input(n, k)

def big_random(q):
  for _ in range(q):
    n = random.randint(maxn // 100, maxn)
    k = random.randint(100, maxk // 100)
    next_file(n, k, 'random')
    random_input(n, k)
  for _ in range(q):
    n = random.randint(100, maxn // 100)
    k = random.randint(maxk // 100, maxk)
    next_file(n, k, 'random')
    random_input(n, k)
  for _ in range(q):
    n = random.randint(maxn // 100, maxn)
    k = random.randint(maxk // 100, maxk)
    next_file(n, k, 'random')
    random_input(n, k)

def max_random(q):
  for _ in range(q):
    n = maxn
    k = maxk
    next_file(n, k, 'random')
    random_input(n, k)

def all_random(q):
  max_random(q)
  big_random(q)
  med_random(q)
  small_random(q)

def special():
  next_file(minn, mink, 'minimal')
  print_case([])
  next_file(maxn, mink, 'no operations')
  print_case([], maxn)
  next_file(minn, maxk, 'minimal width')
  print_case([(c, minn, minn) for c in OPS] * (maxk // len(OPS)))
  for i in [minn, maxn // 2, maxn ]:
    next_file(maxn, maxk, 'only at {}'.format(i))
    print_case([(c, i, i) for c in OPS] * (maxk // len(OPS)), maxn)
  for c in OPS:
    next_file(maxn, 1, 'only op {}'.format(c))
    print_case([(c, minn, maxn)])
  for i in range(len(OPS)):
    next_file(maxn, 2, 'only cancelling ops {} and {}'.format(OPS[i], COPS[i]))
    print_case([(OPS[i], minn, maxn), (COPS[i], minn, maxn)])
  for c in OPS:
    next_file(maxn, maxk, 'same op {}'.format(c))
    print_case([(c, minn, maxn)] * maxk)
  for i in range(len(OPS)):
    next_file(maxn, maxk, 'cancelling ops {} and {}'.format(OPS[i], COPS[i]))
    print_case([(OPS[i], minn, maxn), (COPS[i], minn, maxn)] * (maxk // 2))
  for c in OPS:
    next_file(maxn, maxn, 'same end with op {}'.format(c))
    print_case([(c, i, maxn) for i in range(1, maxn + 1)])
  for c in "HV":
    width = maxn // 3
    k = maxn - width
    next_file(maxn, k, 'overlapping {}'.format(c))
    print_case([(c, i, i + width) for i in range(1, k + 1)])
  for c in "RD":
    next_file(maxn, maxn // 2, 'short disjoint {}'.format(c))
    print_case([(c, i, i) for i in range(1, maxn + 1, 2)])
  next_file(maxn, maxn, 'short alternating RD')
  print_case([("R", i, i) for i in range(1, maxn + 1, 2)] + [("D", i + 1, i + 1) for i in range(1, maxn, 2)])
  for c in "HV":
    width = 100
    k = (maxn - width) // (2 * width)
    next_file(maxn, k, 'long disjoint {}'.format(c))
    print_case([(c, i * 2 * width + 1, i * 2 * width + width) for i in range(k)])
  width = 100
  k = (maxn - width) // (2 * width)
  next_file(maxn, k ** 2, 'long alternating HV')
  print_case([("H", i * 2 * width + 1, i * 2 * width + width) for i in range(k)] + [("V", i * 2 * width + width + 1, i * 2 * width + 2 * width) for i in range(k)])

special()
all_random(2)
#all_random(200)

sys.stdout.close()
