settings.outformat="png";
size(1000);
defaultpen(1.5);
bbox(white, Fill);

pen covered = rgb(0, 0, 1);
pen uncovered = rgb(0.75, 0.75, 1);
pen shading = rgb(0.6, 1.0, 0.6);
pen boundary = rgb(0.0, 1.0, 0.0);

int n = stdin, t = stdin;
pair pts[] = new pair[n];
for (int i = 0; i < n; ++i) {
  real x = stdin, y = stdin;
  pts[i] = (x, y);
}

real x = stdin, y = stdin, theta = stdin;
pair p0 = (x, y);
pair L = (cos(theta), sin(theta));
pair normal = (cos(theta+pi/2), sin(theta+pi/2));
pair p1 = p0 + t*normal;

pair maxP = max(pts), minP = min(pts);
real scale = maxP.x+maxP.y-minP.x-minP.y;

filldraw((p0-scale*L)--(p0+scale*L)--(p1+scale*L)--(p1-scale*L)--cycle,
         fillpen=shading, drawpen=boundary);
for (int i = 0; i < n; ++i) {
  if ((L.x*(pts[i]-p0).y - L.y*(pts[i]-p0).x >= -1e-10*scale) &&
      (L.x*(pts[i]-p1).y - L.y*(pts[i]-p1).x <= 1e-10*scale))
    dot(pts[i], covered);
  else
    dot(pts[i], uncovered);
}

clip(box(min(pts) + (-scale/100, -scale/100), max(pts) + (scale/100, scale/100)));


shipout(bbox(xmargin=10, white, Fill));
