// TODO: check whether the edges of the line are included
// TODO: check EPS calculation, and how numerically stable the problem is

#include <bits/stdc++.h>

using namespace std;

using real_t = long double;
using pnt = complex<real_t>;

static constexpr real_t EPS = 1e-12;
static constexpr real_t PI = M_PIl;

static real_t dot(const pnt &a, const pnt &b)
{
    return real(conj(a) * b);
}

static real_t len2(const pnt &a)
{
    return dot(a, a);
}

struct event
{
    real_t a;
    int delta;

    bool operator<(const event &other) { return a < other.a; }
};

int main()
{
    ios::sync_with_stdio(false);
    int N;
    real_t T;
    cin >> N >> T;
    real_t T2 = T * T;
    vector<pnt> pnts;
    for (int i = 0; i < N; i++)
    {
        int x, y;
        cin >> x >> y;
        pnts.emplace_back(x, y);
    }

    int ans = 2;
    for (int i = 0; i < N; i++)
    {
        vector<event> events;
        int init = 1;
        auto add_interval = [&](real_t start, real_t width)
        {
            start -= EPS;
            while (start < 0.0)
                start += 2 * PI;
            real_t end = start + width + 2 * EPS;
            if (end >= 2 * PI)
            {
                end -= 2 * PI;
                init++;
            }
            events.push_back(event{start, 1});
            events.push_back(event{end, -1});
        };
        for (int j = 0; j < N; j++)
        {
            if (i == j)
                continue;
            real_t d2 = len2(pnts[j] - pnts[i]);
            real_t a1 = arg(pnts[j] - pnts[i]);
            if (a1 < 0)
                a1 += 2 * PI;
            if (d2 <= T2 + EPS)
                add_interval(a1 - PI, PI);
            else
            {
                real_t t = asinl(sqrt(T2 / d2));
                add_interval(a1 - t, t);
                add_interval(a1 - PI, t);
            }
        }
        sort(events.begin(), events.end());
        int level = init;
        for (const event &e : events)
        {
            level += e.delta;
            if (level > ans)
                ans = level;
        }
    }
    cout << ans << '\n';
    return 0;
}
