#include <bits/stdc++.h>
using namespace std;
const double pi = 2.0*acos(0.0);

typedef long long Z;

struct point {
    Z x, y;
    point(Z x=0, Z y=0): x(x), y(y) {}
    point operator-(const point &p) const { return point(x-p.x, y-p.y); }
    double theta() const { return atan2(y, x); }
    double dist() const { return sqrt(x*x + y*y); }
    bool operator==(const point &p) const { return x == p.x && y == p.y; }
};

double angle_mod(double v) {
    if (v < -pi) v += 2*pi;
    if (v > pi) v -= 2*pi;
    return v;
}

int main(int argc, char **argv) {
    bool debug = argc > 1 && !strcmp(argv[1], "debug");
    bool verbose = argc > 1 && !strcmp(argv[1], "verbose");
    int n;
    Z t;
    cin >> n >> t;
    vector<point> P(n);
    for (auto &p: P) cin >> p.x >> p.y;
    int ans = 0;
    point optP;
    double optTheta;
    for (auto c: P) {
        vector<pair<double,int>> E;
        vector<int> status(n+1, -1);
        int x = 0;
        for (int i = 1; i <= n; ++i) {
            if (P[i-1] == c) { ++x; continue; }
            auto q = P[i-1]-c;
            double u = q.theta(), d = q.dist();
            E.push_back(make_pair(u, -i));
            E.push_back(make_pair(angle_mod(u+pi), i));
            if (d > t) {
                double v = asin(t/d);
                if (debug)
                    printf("i %d => u %.9lf, v %.9lf d %.9lf\n", i, u, v, d);
                E.push_back(make_pair(angle_mod(u-v), i));
                E.push_back(make_pair(angle_mod(u+pi+v), -i));
            }
        }
        if (debug) printf("c = %lld %lld, init x %d\n", c.x, c.y, x);
        sort(E.begin(), E.end());
        for (int i = 0; i < 2; ++i)
            for (auto &e: E) {
                int i = abs(e.second), delta = e.second > 0 ? 1 : -1;
                if (debug) printf("ev %.9lf %d %d (status %d, pre-x %d)\n", e.first, i, delta, status[i], x);
                if (status[i] != delta) {
                    x += delta;
                    status[i] = delta;
                }
                if (x > ans) {
                    optP = c;
                    optTheta = e.first;
                    ans = x;
                }
                ans = max(ans, x);
            }
        if (debug) printf("cur ans %d\n", ans);
    }
    if (verbose) {
        cout.precision(15);
        cout << optP.x << " " << optP.y << " " << optTheta << endl;
    }
    cout << ans << endl;
    return 0;
}
