#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2")

// TODO: check whether the edges of the line are included

#include <bits/stdc++.h>

using namespace std;

using pnt = complex<double>;

static double dot(const pnt &a, const pnt &b)
{
    return a.real() * b.real() + a.imag() * b.imag();
}

static double len2(const pnt &a)
{
    return dot(a, a);
}

static double cross(const pnt &a, const pnt &b)
{
    return a.real() * b.imag() - a.imag() * b.real();
}

int main()
{
    ios::sync_with_stdio(false);
    int N;
    double T;
    cin >> N >> T;
    vector<pnt> pnts;
    for (int i = 0; i < N; i++)
    {
        int x, y;
        cin >> x >> y;
        pnts.emplace_back(x, y);
    }

    int ans = 2;
    for (int i = 0; i < N; i++)
        for (int j = i + 1; j < N; j++)
        {
            int inside1 = 0, inside2 = 0;
            pnt vec = pnts[j] - pnts[i];
            double limit = T * sqrt(len2(vec));
            for (int k = 0; k < N; k++)
            {
                double area = cross(vec, pnts[k] - pnts[i]);
                inside1 += (area >= 0 && area <= limit);
                inside2 += (area >= -limit && area <= 0);
            }
            ans = max(ans, inside1);
            ans = max(ans, inside2);
        }
    cout << ans << '\n';
    return 0;
}
