import java.io.*;

class Phone {
    int x, y, z;
}

public class matthias {
    static int n;
    static Phone[] phones;

    static void read_data(BufferedReader inp) throws IOException {
        String line = inp.readLine();
        n = Integer.parseInt(line);
        phones = new Phone[n];

        for (int i = 0; i < n; ++i) {
            line = inp.readLine();
            String[] s = line.split("\\s+");
            Phone p = new Phone();
            p.x = Integer.parseInt(s[0]);
            p.y = Integer.parseInt(s[1]);
            p.z = Integer.parseInt(s[2]);
            phones[i] = p;
        }
    }

    static long dist(Phone a, Phone b, boolean dim_x, boolean dim_y, boolean dim_z) {
        long d = 0;
        if (dim_x) d += Math.max(b.x - a.x, 0);
        if (dim_y) d += Math.max(b.y - a.y, 0);
        if (dim_z) d += Math.max(b.z - a.z, 0);
        return d;
    }

    static long dist(Phone a, Phone b) {
        return dist(a, b, true, true, true);
    }

    static void process_data() {
        Phone zero = new Phone();
        zero.x = zero.y = zero.z = 0;
        long[] max_sum = { 0, 0, 0, 0, 0, 0, 0 };
        int[] best_index = { 0, 0, 0, 0, 0, 0, 0 };
        long d;
        for (int i = 0; i < n; ++i) {
            Phone p = phones[i];
            d = dist(zero, p, true, false, false); if (d > max_sum[0]) { max_sum[0] = d; best_index[0] = i; }
            d = dist(zero, p, false, true, false); if (d > max_sum[1]) { max_sum[1] = d; best_index[1] = i; }
            d = dist(zero, p, false, false, true); if (d > max_sum[2]) { max_sum[2] = d; best_index[2] = i; }
            d = dist(zero, p, true, true, false);  if (d > max_sum[3]) { max_sum[3] = d; best_index[3] = i; }
            d = dist(zero, p, true, false, true);  if (d > max_sum[4]) { max_sum[4] = d; best_index[4] = i; }
            d = dist(zero, p, false, true, true);  if (d > max_sum[5]) { max_sum[5] = d; best_index[5] = i; }
            d = dist(zero, p, true, true, true);   if (d > max_sum[6]) { max_sum[6] = d; best_index[6] = i; }
        }

        long min_cost = 1L<<40;
        int min_cost_index = -1;

        for (int i = 0; i < n; ++i) {
            Phone p = phones[i];
            d = 0;
            for (int j = 0; j < 7; ++j) {
                d = Math.max(d, dist(p, phones[best_index[j]]));
                if (d >= min_cost) break;
            }
            if (d < min_cost) {
                min_cost = d;
                min_cost_index = i;
            }
        }
        System.out.printf("%d %d\n", min_cost, min_cost_index + 1);
    }

    public static void main(String[] args) throws FileNotFoundException, IOException {
        BufferedReader inp = new BufferedReader(new InputStreamReader(System.in));
        read_data(inp);
        process_data();
    }
}
