#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

ll sum(const array<ll,3> &p, int X) {
    ll res = 0;
    for (int i = 0; i < 3; ++i) if (X & (1<<i)) res += p[i];
    return res;
}

struct max_tree {
    int B;
    vector<ll> vals;
    max_tree(int n): B(1) {
        while (B <= n) B *= 2;
        vals.resize(B+n);
    }
    void update(int i, ll v) {
        i += B;
        while (i && vals[i] < v) {
            vals[i] = v;
            i /= 2;
        }
    }
    ll query(int r) {
        r += B;
        ll ans = 0;
        int L = B;
        while (r > 0) {
            ans = max(ans, vals[r]);
            //if (r == L) break;
            r = (r-1)/2;
            L /= 2;
        }
        return ans;
    }
};

int main(void) {
    int n;
    scanf("%d", &n);
    vector<array<ll,3>> phones(n);
    vector<ll> cost(n);

    ll max_sum = 0;
    for (auto &p: phones) {
        scanf("%lld%lld%lld", &p[0], &p[1], &p[2]);
        max_sum = max(max_sum, sum(p, 7));
    }
    for (int i = 0; i < n; ++i)
        cost[i] = max_sum - sum(phones[i], 7);

    vector<int> idx(n);
    iota(idx.begin(), idx.end(), 0);
    for (int d = 0; d < 3; ++d) {
        sort(idx.begin(), idx.end(), [&](int i, int j) {
                if (phones[i][d] != phones[j][d])
                    return phones[i][d] < phones[j][d];
                return sum(phones[i], 7 ^ (1<<d)) > sum(phones[j], 7 ^ (1<<d)); });

        ll max_other = 0;
        for (int i: idx) {
            const auto &p = phones[i];
            ll other = sum(p, 7 ^ (1<<d));
            cost[i] = max(cost[i], max_other - other);
            max_other = max(max_other, other);
        }
        
        vector<ll> y_vals;
        for (const auto &p: phones)
            y_vals.push_back(p[(d+1)%3]);
        sort(y_vals.begin(), y_vals.end());
        y_vals.resize(unique(y_vals.begin(), y_vals.end()) - y_vals.begin());
        map<ll, int> compress;
        for (int i = 0; i < y_vals.size(); ++i)
            compress[y_vals[i]] = i;
        max_tree T(y_vals.size());

        sort(idx.begin(), idx.end(), [&](int i, int j) {
                if (phones[i][d] != phones[j][d])
                    return phones[i][d] < phones[j][d];
                return phones[i][(d+2)%3] > phones[j][(d+2)%3];
            });
        
        for (int i: idx) {
            ll y = phones[i][(d+1)%3], z = phones[i][(d+2)%3];
            cost[i] = max(cost[i], T.query(compress[y]) - z);
            T.update(compress[y], z);
        }
        
    }

    ll opt_v = *min_element(cost.begin(), cost.end());
    for (int i = 0; i < n; ++i)
        if (cost[i] == opt_v) {
            printf("%lld %d\n", opt_v, i+1);
            break;
        }
        
}
