import java.io.*;
import java.util.*;

public final class bmerry
{
    private static final int SCALE = 10000;

    private static int convertCoord(String coord)
    {
        return (int) Math.round(Double.valueOf(coord) * SCALE);
    }

    private static long[] loadMap(BufferedReader in, int N) throws IOException
    {
        long[] points = new long[N];
        for (int i = 0; i < N; i++)
        {
            String[] fields = in.readLine().split(" ");
            long lat = convertCoord(fields[0]) + 90 * SCALE;
            long lon = convertCoord(fields[1]);
            points[i] = (lon << 32) | lat;
        }
        Arrays.sort(points);
        long plon = (points[N - 1] >> 32) - 360 * SCALE;
        for (int i = 0; i < N; i++)
        {
            long lon = points[i] >> 32;
            points[i] -= plon << 32;
            plon = lon;
        }
        return points;
    }

    public static void main(String[] args) throws IOException
    {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        int N = Integer.parseInt(in.readLine());
        long[] map1 = loadMap(in, N);
        long[] map2 = loadMap(in, N);
        int[] fail = new int[N + 1];
        fail[0] = -1;
        for (int i = 1; i <= N; i++)
        {
            long s = map1[i - 1];
            int f = fail[i - 1];
            while (f >= 0 && map1[f] != s)
                f = fail[f];
            fail[i] = f + 1;
        }

        int m = 0;
        for (int i = 0; i < 2 * N; i++)
        {
            long s = map2[(i >= N) ? i - N : i];
            while (m >= 0 && map1[m] != s)
                m = fail[m];
            m++;
            if (m == N)
            {
                System.out.println("Same");
                return;
            }
        }

        System.out.println("Different");
    }
}
