#!/usr/bin/env python3

# Correct solution - Python is just too slow here (sorting is surprisingly slow).

import sys

SCALE = 10000
PACK = 1000000000

def convert_coord(x):
    return int(round(float(x) * SCALE))

def load_coord():
    lat, lon = [convert_coord(x) for x in sys.stdin.readline().split()]
    return lon, lat

def load_map(N):
    points = [load_coord() for _ in range(N)]
    points.sort()
    out = [
        (points[i][0] - points[i - 1][0]) * PACK + points[i][1]
        for i in range(N)
    ]
    out[0] += 360 * SCALE * PACK
    return out

def main():
    N = int(sys.stdin.readline())
    map1 = load_map(N)
    map2 = load_map(N)
    fail = [-1] * (N + 1)
    for i in range(1, N + 1):
        s = map1[i - 1]
        f = fail[i - 1]
        while f >= 0 and map1[f] != s:
            f = fail[f]
        fail[i] = f + 1

    m = 0
    for i in range(2 * N):
        s = map2[i - N]
        while m >= 0 and map1[m] != s:
            m = fail[m]
        m += 1
        if m == N:
            print("Same")
            return

    print("Different")


if __name__ == '__main__':
    main()
