// Tries every possible rotation amount

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

static constexpr int SCALE = 10000;
static constexpr ll COMBINE = 1000000009;
static constexpr ll PERIOD = 360 * SCALE * COMBINE;

static int load_coord()
{
    double x;
    cin >> x;
    return int(round(x * SCALE));
}

static vector<ll> load_map(int N)
{
    vector<ll> points;
    points.reserve(N);
    for (int i = 0; i < N; i++)
    {
        int lat = load_coord() + 90 * SCALE;
        int lon = load_coord() + 180 * SCALE - 1;
        points.push_back(lon * COMBINE + lat);
    }
    return points;
}

int main()
{
    ios::sync_with_stdio(false);
    int N;
    cin >> N;
    auto map1 = load_map(N);
    auto map2 = load_map(N);
    gp_hash_table<ll, null_type> trg(map2.begin(), map2.end());
    for (ll match : map2)
    {
        if (match % COMBINE != map1[0] % COMBINE)
            continue;
        ll rot = (match - map1[0] + PERIOD) % PERIOD;
        for (ll p : map1)
        {
            ll p2 = p + rot;
            if (p2 >= PERIOD)
                p2 -= PERIOD;
            if (trg.find(p2) == trg.end())
                goto bad;
        }

        cout << "Same\n";
        return 0;
bad:;
    }
    cout << "Different\n";
    return 0;
}
