/* Like brute-string.cpp, but if it doesn't find a match after some number
 * of tries it assumes they're different.
 */

#include <bits/stdc++.h>

using namespace std;

using pii = pair<int, int>;
using vi = vector<int>;

static constexpr int SCALE = 10000;

static int load_coord()
{
    double x;
    cin >> x;
    return int(round(x * SCALE));
}

static void encode(string &out, int v)
{
    out += char(v >> 16);
    out += char(v >> 8);
    out += char(v);
}

static string load_map(int N)
{
    vector<pii> points;
    for (int i = 0; i < N; i++)
    {
        int lat = load_coord();
        int lon = load_coord();
        points.emplace_back(lon, lat);
    }
    sort(points.begin(), points.end());
    string out;
    int plon = points.back().first - 360 * SCALE;
    for (int i = 0; i < N; i++)
    {
        encode(out, points[i].first - plon);
        encode(out, points[i].second + 90 * SCALE);
        plon = points[i].first;
    }
    return out;
}

int main()
{
    ios::sync_with_stdio(false);
    int N;
    cin >> N;
    string map1 = load_map(N);
    string map2 = load_map(N);
    map2 += map2;
    int tries = 1000000000;
    for (int i = 0; i < N; i++)
    {
        int j;
        for (j = 0; j < 6 * N; j++)
            if (map1[j] != map2[6 * i + j])
                break;
        if (j == 6 * N)
        {
            cout << "Same\n";
            return 0;
        }
        else
        {
            tries -= j;
            if (tries < 0)
                break;
        }
    }
    cout << "Different\n";
    return 0;
}
