// Based on dk.cc, but reduces hashes mod 2^64, and checks for any hash match
// rather than xoring all the hashes together.

#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <tuple>
#include <vector>
#include <set>
using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(NULL);
  int N;
  while (cin >> N) {
    vector<vector<pair<uint64_t, uint64_t>>> v(2);
    for (int i = 0; i < 2; i++)
    for (int j = 0; j < N; j++) {
      double A, B;
      cin >> A >> B;
      v[i].emplace_back((B+180)*10000-0.5, (A+90)*10000-0.5);
    }

    set<uint64_t> allhash[2];
    uint64_t base = 56789, basen = 1;
    for (int i = 0; i < N; i++) basen = basen * base;
    for (int i = 0; i < 2; i++) {
      sort(v[i].begin(), v[i].end());
      uint64_t hash = 0;
      for (int j = 0; j < N; j++) {
        hash = (hash * base + (v[i][j].second + 69) *
                              ((v[i][(j+1)%N].first + 3600000 - v[i][j].first) % 3600000 + 666));
      }
      for (int j = 0; j < N; j++) {
        hash = (hash * base + (1 - basen) *
                              (v[i][j].second + 69) *
                              ((v[i][(j+1)%N].first + 3600000 - v[i][j].first) % 3600000 + 666));
        allhash[i].insert(hash);
      }
    }
    bool same = false;
    for (uint64_t v : allhash[0])
        if (allhash[1].count(v))
            same = true;
    cout << (same ? "Same" : "Different") << endl;
  }
}
