#!/usr/bin/env python3

import argparse
import random

from utils import print_same_case, SCALE

FULL = 360 * SCALE

parser = argparse.ArgumentParser()
parser.add_argument('N', type=int)
args = parser.parse_args()
N = args.N
if FULL % (N + 1):
    parser.error('N+1 must divide into {}'.format(FULL))

random.seed(567587905 * N)

ratio = FULL // (N + 2)
shift = random.randrange(0, FULL)
coords = [(-45.1234, i * ratio + shift) for i in range(N - 1)]
rot = random.randrange(0, FULL)
print_same_case(coords, rot)
