#!/usr/bin/env python3

import argparse
from utils import print_case, SCALE

parser = argparse.ArgumentParser()
parser.add_argument('N', type=int)
parser.add_argument('--repeat', type=int, default=1)
parser.add_argument('--scale', type=int, default=1)
args = parser.parse_args()
N = args.N

if N <= 1 or (N & (N - 1)):
    parser.error("N must be a power of 2")
if args.repeat * N * 1.5 >= 360 * SCALE:
    parser.error("N is too big")

c1 = []
p1 = 0
c2 = []
p2 = 0
for r in range(args.repeat):
    for i in range(N):
        d = bin(i).count('1') % 2
        p1 += d + 1
        p2 += 2 - d
        c1.append((0, p1 * args.scale))
        c2.append((0, p2 * args.scale))
print_case(c1, c2)
