#!/usr/bin/env python3

import argparse
import random

from utils import print_same_case, SCALE

parser = argparse.ArgumentParser()
parser.add_argument('N', type=int)
args = parser.parse_args()
N = args.N

random.seed(345678907 * N)

FULL = 360 * SCALE
factors = []
for i in range(1, FULL):
    if i * i > FULL:
        break
    if FULL % i == 0:
        factors.append(i)
        if i * i < FULL:
            factors.append(FULL // i)

coords = []
seen_lat = set()
while N > 0:
    limit = max(1, N // 4)
    L = random.choice([f for f in factors if f <= limit])
    P = FULL // L
    phase = random.randrange(0, P)
    while True:
        lat = random.randint(-90 * SCALE + 1, 90 * SCALE - 1)
        if lat not in seen_lat:
            break
    seen_lat.add(lat)
    for i in range(L):
        coords.append((lat, i * P + phase))
    N -= L

rot = random.randint(0, FULL - 1)
print_same_case(coords, rot)
