#!/usr/bin/env python3

import argparse
import random

from utils import print_same_case, SCALE

parser = argparse.ArgumentParser()
parser.add_argument('--lat', type=int)
parser.add_argument('N', type=int)
args = parser.parse_args()
N = args.N
L = args.lat or N

random.seed(567343375 * N + 1234 * L)

lat = random.sample(range(-90 * SCALE + 1, 90 * SCALE), L)
coords = []
seen = set()
for i in range(N):
    while True:
        c = (random.choice(lat), random.randint(-180 * SCALE + 1, 180 * SCALE))
        if c not in seen:
            break
    seen.add(c)
    coords.append(c)

rot = random.randrange(0, 360 * SCALE)
print_same_case(coords, rot)
