#!/bin/bash
set -e -u

function make_almost_cyclic
{
    tools/gen/gen-almost-cyclic.py $2 > data/secret/$1.in
    echo Different > data/secret/$1.ans
    echo "Single latitude, almost cyclic (N = $1)" > data/secret/$1.desc
}

function make_almost_cyclic2
{
    tools/gen/gen-almost-cyclic2.py $2 > data/secret/$1.in
    echo Different > data/secret/$1.ans
    echo "Single latitude, almost cyclic (variant 2) (N = $2)" > data/secret/$1.desc
}

function make_almost_cyclic3
{
    tools/gen/gen-almost-cyclic3.py $2 > data/secret/$1.in
    echo Same > data/secret/$1.ans
    echo "Single latitude, almost cyclic, same (variant 3) (N = $2)" > data/secret/$1.desc
}

function make_random
{
    tools/gen/gen-random.py --lat $2 $3 > data/secret/$1.in
    echo Same > data/secret/$1.ans
    echo "Same, random data, up to $2 latitudes (N = $3)" > data/secret/$1.desc
}

function make_multi_cyclic
{
    tools/gen/gen-multi-cyclic.py $2 > data/secret/$1.in
    echo Same > data/secret/$1.ans
    echo "Multiple latitudes with periodic points (N = $2)" > data/secret/$1.desc
}

function make_antihash
{
    tools/gen/gen-antihash.py $2 --repeat $3 --scale $4 > data/secret/$1.in
    echo Different > data/secret/$1.ans
    echo "Break hashing solutions that work mod 2^k" > data/secret/$1.desc
}

if ! [ -x tools/make_cases.sh ]; then
    echo "Run from top of problem directory" 1>&2
    exit 2
fi

make_multi_cyclic 10 13

make_almost_cyclic 20 400000
make_almost_cyclic 21 360000
make_almost_cyclic 22 300000
make_almost_cyclic2 23 399998
make_almost_cyclic2 24 359998
make_almost_cyclic2 25 299998
make_almost_cyclic3 26 399999
make_almost_cyclic3 27 359999
make_almost_cyclic3 28 299999
make_random 29 400000 400000
make_random 30 1 400000
make_random 31 1000 400000
make_multi_cyclic 32 400000
make_multi_cyclic 33 399999
make_multi_cyclic 34 399998
make_multi_cyclic 35 399997
make_antihash 40 262144 1 1
make_antihash 41 262144 1 131
make_antihash 42 2048 10 17
ruby tools/generate_cases_matthias.rb
