import java.io.*;
import java.util.*;

public final class bmerry
{

    private static final class State
    {
        private BitSet[] implies;
        private BitSet known;
        private BitSet allBad;

        public State(int M)
        {
            implies = new BitSet[M];
            for (int i = 0; i < M; i++)
            {
                implies[i] = new BitSet(M);
                implies[i].set(i);
            }
            known = new BitSet(M);
            allBad = new BitSet(M);
            for (int i = 1; i < M; i += 2)
                allBad.set(i);
        }

        public void add(int x, int y)
        {
            if (implies[x].get(y))
                return;
            implies[x].set(y);
            implies[y ^ 1].set(x ^ 1);
        }

        public void update()
        {
            int M = implies.length;
            boolean more = true;
            while (more)
            {
                for (int y = 0; y < M; y++)
                    for (int x = 0; x < M; x++)
                        if (implies[x].get(y))
                            implies[x].or(implies[y]);
                for (int i = 0; i < M; i++)
                    if (implies[i ^ 1].get(i))
                        known.set(i);
                more = false;
                for (int i = 0; i < M; i++)
                {
                    if (known.get(i ^ 1))
                        continue;
                    BitSet cknown = (BitSet) known.clone();
                    cknown.or(implies[i]);
                    cknown.and(allBad);
                    if (cknown.cardinality() * 4 >= M)
                    {
                        more = true;
                        implies[i].set(i ^ 1);
                    }
                }
                for (int i = 0; i < M; i++)
                    for (int j = i + 1; j < M; j++)
                    {
                        if ((i >> 1) == (j >> 1))
                            continue;
                        if (known.get(i ^ 1) || known.get(j ^ 1) || implies[i].get(j ^ 1))
                            continue;
                        BitSet cknown = (BitSet) known.clone();
                        cknown.or(implies[i]);
                        cknown.or(implies[j]);
                        cknown.and(allBad);
                        if (cknown.cardinality() * 4 >= M)
                        {
                            more = true;
                            implies[i].set(j ^ 1);
                            implies[j].set(i ^ 1);
                        }
                    }
            }
        }

        public boolean tested(int x, int y)
        {
            return implies[2 * x].get(2 * y) || implies[2 * x].get(2 * y + 1);
        }

        public int knownCount() { return known.cardinality(); }

        public int status(int x)
        {
            if (known.get(2 * x))
                return 1;
            else if (known.get(2 * x + 1))
                return 0;
            else
                return -1;
        }
    }

    public static void main(String[] args)
    {
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int cas = 0; cas < T; cas++)
        {
            int N = in.nextInt();
            State s = new State(2 * N);
            int nq = 0;
            int[] perm = new int[N];
            int[] rperm = new int[N];
            for (int i = 0; i < N; i++)
                perm[i] = i;
            Random engine = new Random();
            // Shuffle the permutation
            for (int i = N - 1; i > 0; i--)
            {
                int trg = engine.nextInt(i + 1);
                int tmp = perm[i];
                perm[i] = perm[trg];
                perm[trg] = tmp;
            }
            for (int i = 0; i < N; i++)
                rperm[perm[i]] = i;
            while (s.knownCount() < N)
            {
                int[] query = new int[N];
                Arrays.fill(query, -1);
                ArrayList<Integer> good = new ArrayList<Integer>();
                ArrayList<Integer> bad = new ArrayList<Integer>();
                ArrayList<Integer> ugly = new ArrayList<Integer>();
                for (int i = 0; i < N; i++)
                {
                    switch (s.status(i))
                    {
                    case 1: good.add(i); break;
                    case 0: bad.add(i); break;
                    case -1: ugly.add(i); break;
                    }
                }
                Collections.shuffle(good);
                Collections.shuffle(bad);
                Collections.shuffle(ugly);
                int uu = Math.min(good.size(), ugly.size());
                for (int i = 0; i < uu; i++)
                    query[good.get(i)] = ugly.get(i);
                ArrayList<Integer> order = new ArrayList<Integer>();
                for (int x : good)
                    order.add(x);
                for (int x : bad)
                    order.add(x);
                for (int i = uu; i < ugly.size(); i++)
                    order.add(ugly.get(i));
                for (int x : ugly)
                {
                    if (order.isEmpty())
                        break;
                    int end = order.size() - 1;
                    int p = end;
                    while (p >= 0 && s.tested(x, order.get(p)))
                        p--;
                    if (p < 0)
                        continue;
                    int tmp = order.get(p);
                    order.set(p, order.get(end));
                    order.set(end, tmp);
                    query[x] = order.get(end);
                    order.remove(end);
                }
                System.out.print("test");
                for (int i = 0; i < N; i++)
                {
                    int q = query[rperm[i]];
                    System.out.print(" " + (q == -1 ? 0 : perm[q] + 1));
                }
                System.out.println();
                String answer = in.next();
                for (int i = 0; i < N; i++)
                {
                    if (query[i] == -1)
                        continue;
                    int v = answer.charAt(perm[i]) - '0';
                    s.add(2 * i, 2 * query[i] + 1 - v);
                }
                s.update();
                nq++;
            }

            System.out.print("answer ");
            for (int i = 0; i < N; i++)
                System.out.print(s.status(rperm[i]));
            System.out.println();
        }
    }
}
