#!/usr/bin/env python3
import random
import sys
known = []
sol = []

def done():
    res = 0
    for i in range(n):
        if known[2*i][2*i+1] or known[2*i+1][2*i]:
            sol[i] = known[2*i+1][2*i]
            res += 1
            continue
        a = b = 0
        for j in range(n):
            a += known[2*i][2*j+1]
            b += known[2*i+1][2*j+1]
        if 2*a >= n or 2*b >= n:
            sol[i] = 1*(2*a < n)
            res += 1
            continue
    return res

def add_implication(i, j):
    if not known[i][j]:
        for a in range(2*n):
            if known[a][i]:
                for b in range(2*n):
                    known[a][b] |= known[j][b]

def process(perm, response):
    for i in range(n):
        if perm[i] == -1: continue
        o = 2*perm[i] + (response[i] == '0')
        add_implication(2*i, o)
        add_implication(o^1, 2*i+1)

def next_query():
    good = []
    unknown = []
    done()
    for i in range(n):
        if sol[i] == 1: good.append(i)
        elif sol[i] == -1: unknown.append(i)
    random.shuffle(unknown)

    res = [-1]*n
    for x in good:
        if unknown:
            res[x] = unknown.pop()
    if unknown:
        prev = unknown[-1]
        for x in unknown:
            res[prev] = x
            prev = x
    return res

def run_once():
    global known, sol, n
    n = int(sys.stdin.readline())
    known = [[0]*(2*n) for _ in range(2*n)]
    for i in range(2*n): known[i][i] = 1
    sol = [-1]*n    
    while done() != n:
        query = next_query()
        sys.stdout.write('test %s\n' % ' '.join(str(v+1) for v in query))
        sys.stdout.flush()

        ans = sys.stdin.readline()
        process(query, ans)

    sys.stdout.write("answer %s\n" % ''.join(map(str, sol)))
    sys.stdout.flush()

test_cnt = int(sys.stdin.readline())
for _ in range(test_cnt): run_once()
