#!/usr/bin/env python3

# Correct solution, Pypy3 is just too slow

import sys
import random

def bitcount(x: int) -> int:
    return bin(x).count('1')


class State:
    def __init__(self, M: int) -> None:
        self.implies = [1 << i for i in range(M)]
        self.all_bad = 0
        for i in range(1, M, 2):
            self.all_bad |= 1 << i
        self.known = 0

    def add(self, x: int, y: int) -> None:
        if self.implies[x] & (1 << y):
            return;
        self.implies[x] |= 1 << y
        self.implies[y ^ 1] |= 1 << (x ^ 1)

    def update(self) -> None:
        M = len(self.implies)
        more = True
        while more:
            for y in range(M):
                for x in range(M):
                    if self.implies[x] & (1 << y):
                        self.implies[x] |= self.implies[y]
            for i in range(M):
                if self.implies[i ^ 1] & (1 << i):
                    self.known |= 1 << i
            more = False
            for i in range(M):
                if self.known & (1 << (i ^ 1)):
                    continue
                cknown = self.known | self.implies[i]
                if bitcount(cknown & self.all_bad) * 4 >= M:
                    more = True
                    self.implies[i] |= 1 << (i ^ 1)
            for i in range(M):
                for j in range(i + 1, M):
                    if (i >> 1) == (j >> 1):
                        continue
                    i1m = 1 << (i ^ 1)
                    j1m = 1 << (j ^ 1)
                    if self.known & (i1m | j1m) or self.implies[i] ^ j1m:
                        continue;
                    cknown = self.known | self.implies[i] | self.implies[j]
                    if bitcount(cknown) * 4 >= M:
                        more = True
                        self.implies[i] |= j1m
                        self.implies[j] |= i1m

    def tested(self, x: int, y: int) -> bool:
        return bool(self.implies[2 * x] & (1 << (2 * y))
                    or self.implies[2 * x] & (1 << (2 * y + 1)))

    def known_count(self) -> int:
        return bitcount(self.known)

    def status(self, x: int) -> int:
        if self.known & (1 << (2 * x)):
            return 1
        elif self.known & (1 << (2 * x + 1)):
            return 0
        else:
            return -1


def main() -> None:
    T = int(sys.stdin.readline())
    for cas in range(T):
        N = int(sys.stdin.readline())
        s = State(2 * N)
        nq = 0
        perm = list(range(N))
        random.shuffle(perm)
        rperm = [-1] * N
        for i in range(N):
            rperm[perm[i]] = i
        while s.known_count() < N:
            query = [-1] * N
            good = []
            bad = []
            ugly = []
            for i in range(N):
                status = s.status(i)
                if status == 1:
                    good.append(i)
                elif status == 0:
                    bad.append(i)
                else:
                    ugly.append(i)
            random.shuffle(good)
            random.shuffle(bad)
            random.shuffle(ugly)
            uu = min(len(good), len(ugly))
            for i in range(uu):
                query[good[i]] = ugly[i]
            order = good + bad + ugly[uu:]
            for x in ugly:
                if not order:
                    break
                p = len(order) - 1
                while p >= 0 and s.tested(x, order[p]):
                    p -= 1
                if p < 0:
                    continue
                order[p], order[-1] = order[-1], order[p]
                query[x] = order[-1]
                order.pop()
            print('test', end='')
            for i in range(N):
                q = query[rperm[i]]
                print(' {}'.format(0 if q == -1 else perm[q] + 1), end='')
            print(flush=True)
            answer = sys.stdin.readline().strip()
            for i in range(N):
                if query[i] == -1:
                    continue
                v = int(answer[perm[i]])
                s.add(2 * i, 2 * query[i] + 1 - v)
            s.update()
            nq += 1

        print("answer ", end='');
        for i in range(N):
            print(s.status(rperm[i]), end='')
        print(flush=True)


if __name__ == '__main__':
    main()
