import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.*;

/**
 * ICPC 2020 World Finals
 * Incorrect problem solution: QC QC
 * 
 * This is derived from a correct solution but in addition it produces
 * an incorrect test line with an incorrect format.
 * The purpose is to test the validator, which must yield "wrong answer".
 * 
 * @author Martin Kacer
 */
public class QcqcBadIndexTooHigh {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() {
		while (!st.hasMoreTokens()) try {
			String line = input.readLine();
			if (line == null) return false;
			st = new StringTokenizer(line);
		} catch (Exception ex) { throw new RuntimeException(ex); }
		return true;
	}
	String nextToken() {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	public static void main(String[] args) throws Exception {
		QcqcBadIndexTooHigh instance = new QcqcBadIndexTooHigh();
		int testcnt = instance.nextInt();
		while (testcnt-- > 0) instance.solve();
	}
	
	static class Pair<L,R> {
		final L left; final R right;
		Pair(L left, R right) { this.left = left; this.right = right; }
		@Override public String toString() { return "("+left+","+right+")"; };
	}
	
	static final int MAX = 100;
	int n, round;
	Collection<Set<Integer>> active;
	LinkedList<Pair<Set<Integer>,Set<Integer>>> paired;
	LinkedList<Set<Integer>> leftover;
	Set<Integer> good;

	List<Pair<Integer,Integer>> tests = new ArrayList<>();
	int[] testX = new int[MAX], testIdx = new int[MAX];
	boolean[] testR = new boolean[MAX];
	void testStart() { tests.clear(); }
	void test(Integer a, Integer b) { tests.add(new Pair<>(a, b)); }
	int testCnt() { return tests.size(); }
	boolean testRes(int i) { return testR[i]; }
	boolean testOf(int a) { return testR[testIdx[a]]; }
	
	void testRun() {
		Arrays.fill(testX, 0, n, -1);
		int idx = 0;
		for (Pair<Integer,Integer> t : tests) { testX[t.left] = t.right; testX[t.right] = t.left; testIdx[t.left] = testIdx[t.right] = idx++; }
		System.out.print("test");
		for (int i = 0; i < n; ++i) System.out.print(" " + (testX[i]+1));
		System.out.println();
		System.out.flush();
		char[] res = nextToken().toCharArray();
		idx = 0;
		for (Pair<Integer,Integer> t : tests) testR[idx++] = (res[t.left] == '1' && res[t.right] == '1');
	}

	void solve() {
		n = nextInt();
		active = new LinkedList<>();
		paired = new LinkedList<>();
		leftover = new LinkedList<>();
		for (int i = 0; i < n; ++i) active.add(new HashSet<>(Collections.singleton(i)));

		// additional (and incorrect) test
		System.out.print("test");
		for (int i = 0; i < n; ++i) System.out.print(i == 13 ? " " + (n+1) : " 0");
		System.out.println();
		System.out.flush();
		nextToken();
		
		phaseOne();
		System.err.println("1ACTV: " + active); System.err.println("1LEFT: " + leftover); System.err.println("1PAIR: " + paired);
		intermediate();
		System.err.println("iGOOD: " + good); System.err.println("iPAIR: " + paired);
		while (!paired.isEmpty())
			phaseTwo();
		System.err.println("2GOOD: " + good);
		System.out.print("answer ");
		for (int i = 0; i < n; ++i) System.out.print(good.contains(i) ? '1' : '0');
		System.out.println();
		System.out.flush();
	}
	
	void phaseOne() {
		for (round = 0; active.size() > 1; ++round) {
			int acts = active.size();
			testStart();
			Iterator<Set<Integer>> it = active.iterator();
			for (int i = 0; i*2+1 < acts; ++i) test(it.next().iterator().next(), it.next().iterator().next());
			Set<Integer> odd = null;
			if (it.hasNext()) {
				odd = it.next();
				Iterator<Integer> oit = odd.iterator();
				Iterator<Set<Integer>> lit = leftover.iterator();
				while (lit.hasNext())
					test(oit.next(), lit.next().iterator().next());
			}
			testRun();
			it = active.iterator();
			for (int i = 0; i*2+1 < acts; ++i) {
				Set<Integer> grp = it.next();
				if (testRes(i)) {
					grp.addAll(it.next());
				} else {
					it.remove();
					paired.add(new Pair<>(grp, it.next()));
				}
				it.remove();
			}
			if (odd != null) {
				it.next(); it.remove();
				Iterator<Integer> oit = new ArrayList<>(odd).iterator();
				Iterator<Set<Integer>> lit = leftover.iterator();
				while (lit.hasNext())
					if (testOf(oit.next())) {
						odd.addAll(lit.next());
						lit.remove();
					} else
						lit.next();
				leftover.add(odd);
			}
		}
	}
	
	void intermediate() {
		good = new HashSet<>();
		if (active.isEmpty()) {
			testStart();
			test(leftover.getLast().iterator().next(), paired.getLast().left.iterator().next());
			testRun();
			good.addAll(leftover.getLast());
			good.addAll(testRes(0) ? paired.getLast().left : paired.getLast().right);
			paired.removeLast();
		} else {
			good.addAll(active.iterator().next());
			if (!leftover.isEmpty()) {
				testStart();
				Iterator<Integer> ait = active.iterator().next().iterator();
				Iterator<Set<Integer>> lit = leftover.iterator();
				while (lit.hasNext())
					test(ait.next(), lit.next().iterator().next());
				testRun();
				ait = active.iterator().next().iterator();
				lit = leftover.iterator();
				while (lit.hasNext())
					if (testOf(ait.next())) {
						good.addAll(lit.next());
					} else
						lit.next();
			}
		}
	}
	
	void phaseTwo() {
		int pcnt = 0;
		for (Pair<Set<Integer>,Set<Integer>> p : paired) pcnt += p.left.size() + p.right.size();
		Iterator<Pair<Set<Integer>, Set<Integer>>> pit = paired.iterator();
		Iterator<Integer> git = good.iterator();
		testStart();
		if (2 * good.size() <= n - pcnt + 2) {
			while (git.hasNext() && pit.hasNext())
				test(git.next(), pit.next().left.iterator().next());
			testRun();
			pit = paired.iterator();
			for (int i = 0; i < testCnt(); ++i) {
				good.addAll(testRes(i) ? pit.next().left : pit.next().right);
				pit.remove();
			}
		} else {
			for (int i = 0; i+1 < good.size() && pit.hasNext(); i += 2) {
				Pair<Set<Integer>, Set<Integer>> p = pit.next();
				test(git.next(), p.left.iterator().next());
				test(git.next(), p.right.iterator().next());
			}
			testRun();
			pit = paired.iterator();
			for (int i = 0; i < testCnt(); i += 2) {
				Pair<Set<Integer>, Set<Integer>> p = pit.next();
				if (testRes(i)) good.addAll(p.left);
				else if (testRes(i+1)) good.addAll(p.right);
				pit.remove();
			}
		}
	}
}
