import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * ICPC 2019 World Finals
 * Incorrect problem solution: QC QC
 * 
 * 1. Repeat 7 test rounds:
 * - In each round R, a pairwise test is done between machines with the distance 2^(R-1).
 * 2. Report the largest component of machines classifying each other correct.
 * 
 * @author Martin Kacer
 */
public class QcqcPairsExp1MK {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception {
		QcqcPairsExp1MK instance = new QcqcPairsExp1MK();
		int testcnt = Integer.parseInt(instance.input.readLine());
		while (testcnt-- > 0) instance.run();
	}
	
	int size;
	boolean[][] equiv;
	int[] comp, compsize;

	void run() throws Exception {
		size = Integer.parseInt(input.readLine());
		equiv = new boolean[size][size];
		int[] test = new int[size];
		for (int round = 0; round < 7; ++round) {
			int shift = 1 << round;
			Arrays.fill(test, -1);
			for (int i = 0; i < size; ++i) {
				int j = (i + shift) % size;
				if (test[i] >= 0 || test[j] >= 0) continue;
				test[i] = j;
				test[j] = i;
			}
			System.out.print("test");
			for (int i = 0; i < size; ++i) System.out.print(" " + (test[i]+1));
			System.out.println();
			System.out.flush();
			String res = input.readLine();
			for (int i = 0; i < size; ++i) if (test[i] > i) {
				if (res.charAt(i) == '1' && res.charAt(test[i]) == '1')
					equiv[i][test[i]] = equiv[test[i]][i] = true;
			}
		}
		
		comp = new int[size]; compsize = new int[size];
		Arrays.fill(comp, -1);
		int max = 0;
		for (int i = 0; i < size; ++i) {
			compsize[i] = dfs(i, i);
			if (compsize[i] > compsize[max]) max = i;
		}
		
		boolean[] ans = new boolean[size];
		for (int i = 0; i < size; ++i)
			ans[i] = (comp[i] == max);

		System.out.print("answer ");
		for (int i = 0; i < size; ++i)
			System.out.print(ans[i] ? '1' : '0');
		System.out.println();
		System.out.flush();
	}
	
	int dfs(int m, int repr) {
		if (comp[m] >= 0) return 0;
		comp[m] = repr;
		int cnt = 1;
		for (int i = 0; i < size; ++i)
			if (equiv[m][i])
				cnt += dfs(i, repr);
		return cnt;
	}
}
