import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Random;
import java.util.StringTokenizer;

/**
 * ICPC 2019 World Finals
 * Incorrect problem solution: QC QC
 * 
 * This solution is inspired by Majk's suggestion.
 * 1. Tests machines in random pairs for MAX_QUERIES rounds.
 * 2. Each pair of machines which classifies each other correct is connected with an edge.
 * 3. After MAX_QUERIES rounds, the largest connected group is assumed working correctly.
 * 
 * @author Martin Kacer
 */
public class QcqcPairsRandomMK {
	static final int MAX_QUERIES = 12;
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception {
		QcqcPairsRandomMK instance = new QcqcPairsRandomMK();
		int testcnt = Integer.parseInt(instance.input.readLine());
		while (testcnt-- > 0) instance.run();
	}
	Random rand = new Random(424242L);
	
	int size;
	boolean[][] equiv;
	int[] comp, compsize;

	void run() throws Exception {
		size = Integer.parseInt(input.readLine());
		equiv = new boolean[size][size];
		List<Integer> machines = new ArrayList<>(size);
		for (int i = 0; i < size; ++i) machines.add(i);
		int[] test = new int[size];
		for (int round = 0; round < MAX_QUERIES; ++round) {
			Collections.shuffle(machines, rand);
			for (int i = 0; i < size-1; i += 2) {
				test[machines.get(i)] = machines.get(i+1);
				test[machines.get(i+1)] = machines.get(i);
			}
			if (size % 2 == 1) test[machines.get(size-1)] = machines.get(size-1);
			System.out.print("test");
			for (int i = 0; i < size; ++i) System.out.print(" " + (test[i]+1));
			System.out.println();
			System.out.flush();
			String res = input.readLine();
			for (int i = 0; i < size-1; i += 2) {
				if (res.charAt(machines.get(i)) == '1' && res.charAt(machines.get(i+1)) == '1')
					equiv[machines.get(i)][machines.get(i+1)] = equiv[machines.get(i+1)][machines.get(i)] = true;
			}
		}
		
		comp = new int[size]; compsize = new int[size];
		Arrays.fill(comp, -1);
		int max = 0;
		for (int i = 0; i < size; ++i) {
			compsize[i] = dfs(i, i);
			if (compsize[i] > compsize[max]) max = i;
		}
		
		boolean[] ans = new boolean[size];
		for (int i = 0; i < size; ++i)
			ans[i] = (comp[i] == max);

		System.out.print("answer ");
		for (int i = 0; i < size; ++i)
			System.out.print(ans[i] ? '1' : '0');
		System.out.println();
		System.out.flush();
	}
	
	int dfs(int m, int repr) {
		if (comp[m] >= 0) return 0;
		comp[m] = repr;
		int cnt = 1;
		for (int i = 0; i < size; ++i)
			if (equiv[m][i])
				cnt += dfs(i, repr);
		return cnt;
	}
}
