// Makes random queries and infers as much as possible from them.
// Should get WA.
#include <bits/stdc++.h>
using namespace std;

typedef vector<int> vi;
typedef vector<vi> matrix;

struct State {
    matrix known;
    int n;

    State(int n): n(n), known(matrix(2*n, vi(2*n, 0))) {
        for (int i = 0; i < 2*n; ++i)
            known[i][i] = true;
    }

    int done(string &sol) {
        int res = 0;
        for (int i = 0; i < n; ++i) {
            if (known[2*i][2*i+1] || known[2*i+1][2*i]) {
                sol[i] = known[2*i][2*i+1] ? '0' : '1';
                ++res;
                continue;
            }
            int a = 0, b = 0;
            for (int j = 0; j < n; ++j) {
                a += known[2*i][2*j+1];
                b += known[2*i+1][2*j+1];
            }
            if (2*a >= n || 2*b >= n) {
                sol[i] = 2*a >= n ? '0' : '1';
                ++res;
                continue;
            }
        }
        return res;
    }

    void add_implication(int i, int j) {
        if (!known[i][j])
            for (int a = 0; a < 2*n; ++a)
                if (known[a][i])
                    for (int b = 0; b < 2*n; ++b)
                        known[a][b] |= known[j][b];
    }

    
    void process(const vi &perm, const string &response) {
        for (int i = 0; i < n; ++i) {
            if (perm[i] == -1) continue;
            int o = 2*perm[i] + (response[i] == '0');
            add_implication(2*i, o);
            add_implication(o^1, 2*i+1);
        }
    }

    vi next_query() { // Random permutation
        vi res(n);
        iota(res.begin(), res.end(), 0);
        random_shuffle(res.begin(), res.end());
        return res;
    }
};

void run_once() {
    int n;
    scanf("%d", &n);
    State S(n);
    string sol(n, ' ');
    while (S.done(sol) != n) {
        auto query = S.next_query();
        printf("test");
        for (int v: query)
            printf(" %d", v+1);
        printf("\n");
        fflush(stdout);

        char answer[n+100];
        scanf("%s", answer);
        S.process(query, answer);
    }
    printf("answer %s\n", sol.c_str());
    fflush(stdout);
}

int main(void) {
    int testcnt;
    scanf("%d", &testcnt);
    while (testcnt-->0)
        run_once();
}
