import java.io.*;
import java.util.*;

public class Arknave {
    static int v;
    static int c;

    static boolean DEBUG = false;

    public static void main(String[] args) throws IOException {
        final BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer(br.readLine());

        final int n = Integer.parseInt(st.nextToken());
        v = Integer.parseInt(st.nextToken());
        c = Integer.parseInt(st.nextToken());

        int totalXP = 0;
        final Level[] levels = new Level[n];
        for (int i = 0; i < n; i++) {
            st = new StringTokenizer(br.readLine());
            int xp = Integer.parseInt(st.nextToken());
            int target = Integer.parseInt(st.nextToken());
            levels[i] = new Level(xp, target);

            totalXP += xp;
        }

        Arrays.sort(levels);

        final boolean[] dp = new boolean[totalXP + 1];
        dp[0] = true;
        for (Level level : levels) {
            int start = Math.min((v * level.target + c - 1) / c - 1, totalXP - level.xp);
            for (int j = start; j >= 0; --j) {
                dp[j + level.xp] |= dp[j];
            }

            if (DEBUG) {
                for (int i = 0; i < totalXP; i++) {
                    if (dp[i]) {
                        System.err.printf("%d ", i);
                    }
                }
                System.err.println();
            }
        }

        int ans = totalXP;
        while (!dp[ans]) {
            ans--;
        }

        if (DEBUG) {
            System.out.printf("Last: %d%n", ans);
        }

        ans = totalXP + (c - 1) * ans;

        System.out.println(ans);
    }

    public static class Level implements Comparable<Level> {
        private int xp;
        private int target;

        public Level(int xp, int target) {
            this.xp = xp;
            this.target = target;
        }

        public int getScore() {
            return c * xp + v * target;
        }

        public int compareTo(Level other) {
            return Integer.compare(this.getScore(), other.getScore());
        }
    }
}
