#include <bits/stdc++.h>

using namespace std;

using level = pair<int, int>;

constexpr int MAXT = 2000 * 2000;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, v, c;
    cin >> n >> v >> c;

    int tot = 0;
    // exp, target level
    vector<level> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;

        tot += a[i].first;
    }

    // sort by deadlines - max exp you can have _after_ completion
    sort(begin(a), end(a), [&](const level& x, const level& y) {
        return (c * x.first + v * x.second) < (c * y.first + v * y.second);
    });

    bitset<MAXT + 1> dp;
    dp.set(0);
    for (level& lvl : a) {
        // naive: iterate over all values descending, do normal knapsack
        // optimization, use math to figure out exactly where to start.

        // c * x < v * d
        // x < v * d / c
        int start = min((v * lvl.second + c - 1) / c - 1, tot - lvl.first);
        bitset<MAXT + 1> mask;
        for (int j = 0; j <= start; ++j) {
            mask.set(j);
        }

        dp = dp | ((dp & mask) << lvl.first);
    }

    int ans = tot;
    while (!dp[ans])
        --ans;

    ans = tot + (c - 1) * ans;

    cout << ans << '\n';

    return 0;
}
