#include <bits/stdc++.h>

using namespace std;

using ull = unsigned long long;
using level = pair<int, int>;

// 65k * 64 > 2000^2
constexpr int SZ = 1 << 16;
ull dp[SZ];

inline void update(ull bits, int start) {
    int dp_idx = start >> 6;
    int boost = start & 0x3f;
    dp[dp_idx] |= bits << boost;
    if (boost) {
        dp[dp_idx + 1] |= bits >> (64ULL - boost);
    }
}

inline void shift(int cap, int amt) {
    for (int i = (cap >> 6); i >= 0; --i) {
        ull bits = dp[i];
        if (bits == 0) {
            continue;
        }

        int low_bit = i << 6;
        if (low_bit <= cap and cap < low_bit + 64) {
            int num_bits = (cap + 1) & 0x3f;
            bits &= (1ULL << num_bits) - 1;
        }

        update(bits, low_bit + amt);
    }
}

int get_last() {
    for (int i = SZ - 1; i >= 0; --i) {
        if (dp[i]) {
            for (int j = 63; j >= 0; --j) {
                if (dp[i] & (1ULL << j)) {
                    return (i << 6) | j;
                }
            }
        }
    }

    return -1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, v, c;
    cin >> n >> v >> c;

    int tot = 0;
    vector<level> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;

        tot += a[i].first;
    }

    sort(begin(a), end(a), [&](const level& x, const level& y) {
        return (c * x.first + v * x.second) < (c * y.first + v * y.second);
    });

    dp[0] = 1;
    for (level& lvl : a) {
        int start = min((v * lvl.second + c - 1) / c - 1, tot - lvl.first);
        shift(start, lvl.first);
    }

    int ans = get_last();
    ans = tot + (c - 1) * ans;

    cout << ans << '\n';

    return 0;
}
