#include <bits/stdc++.h>

using namespace std;

using level = pair<int, int>;

int gcd(int a, int b) {
    return b ? gcd(b, a % b) : a;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, v, c;
    cin >> n >> v >> c;

    // minor optimization: take the gcd of all XP values, divide
    // out. Makes for a smaller dp array.

    int tot = 0;
    // exp, target level
    vector<level> a(n);
    int g = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;

        tot += a[i].first;
        g = gcd(g, tot);
    }

    tot /= g;
    for (int i = 0; i < n; ++i) {
        a[i].first /= g;
    }
    // sort by deadlines - max exp you can have _after_ completion
    sort(begin(a), end(a), [&](const level& x, const level& y) {
        return (c * x.first + v * x.second) < (c * y.first + v * y.second);
    });

    vector<char> dp(tot + 1, false);
    dp[0] = true;
    for (level& lvl : a) {
        // naive: iterate over all values descending, do normal knapsack
        // optimization, use math to figure out exactly where to start.

        // c * g * x < v * d
        // x < v * d / (g * c)
        int start = min((v * lvl.second + g * c - 1) / g / c - 1, tot - lvl.first);
        for (int j = start; j >= 0; --j) {
            dp[j + lvl.first] |= dp[j];
        }
    }

    int ans = tot;
    while (!dp[ans])
        --ans;

    ans = tot + (c - 1) * ans;

    ans *= g;

    cout << ans << '\n';

    return 0;
}
