#include <bits/stdc++.h>

using namespace std;

using level = pair<int, int>;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, v, c;
    cin >> n >> v >> c;

    int tot = 0;
    // exp, target level
    vector<level> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;

        tot += a[i].first;
    }

    // sort by deadlines - max exp you can have _after_ completion
    sort(begin(a), end(a), [&](const level& x, const level& y) {
        return (c * x.first + v * x.second) < (c * y.first + v * y.second);
    });

    vector<int> suffix_sums(n);
    suffix_sums[n - 1] = a[n - 1].first;
    for (int i = n - 2; i >= 0; --i) {
        suffix_sums[i] = a[i].first + suffix_sums[i + 1];
    }

    vector<char> dp(tot + 1, false);
    dp[0] = true;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        // naive: iterate over all values descending, do normal knapsack
        // optimization, use math to figure out exactly where to start.
        int xp, target;
        tie(xp, target) = a[i];

        // c * x < v * d
        // x < v * d / c
        int start = min((v * target + c - 1) / c - 1, tot - xp);
        for (int j = start; j >= 0 and j + suffix_sums[i] > ans; --j) {
            if (dp[j]) {
                dp[j + xp] = true;
                ans = max(ans, j + xp);
            }
        }
    }

    ans = tot + (c - 1) * ans;

    cout << ans << '\n';

    return 0;
}
