#include <bits/stdc++.h>

using namespace std;

using ull = unsigned long long;
using level = pair<int, int>;

// 4M is about 2^22
constexpr int H = 11;
constexpr int SZ = 1 << H;
constexpr int MASK = SZ - 1;
bitset<SZ> dp[SZ];
bitset<SZ> full;

inline void update(const bitset<SZ>& val, int start) {
    int dp_idx = start >> H;
    int boost = start & MASK;
    dp[dp_idx] |= (val << boost) & full;
    if (boost) {
        dp[dp_idx + 1] |= val >> (SZ - boost);
    }
}

inline void shift(int cap, int amt) {
    for (int i = (cap >> H); i >= 0; --i) {
        if (!dp[i].count()) {
            continue;
        }

        int low_bit = i << H;
        bitset<SZ> row = dp[i];
        if (low_bit <= cap and cap < low_bit + SZ) {
            int num_bits = (cap + 1) & MASK;
            for (int j = SZ - 1; j >= num_bits; --j) {
                row.set(j, false);
            }
        }
        update(row, low_bit + amt);
    }
}

int get_last() {
    for (int i = SZ - 1; i >= 0; --i) {
        if (!dp[i].count()) continue;
        for (int j = SZ - 1; j >= 0; --j) {
            if (dp[i][j]) {
                return (i << H) | j;
            }
        }
    }

    return -1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    for (int i = 0; i < SZ; ++i) {
        full.set(i);
    }

    int n, v, c;
    cin >> n >> v >> c;

    int tot = 0;
    vector<level> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;

        tot += a[i].first;
    }

    sort(begin(a), end(a), [&](const level& x, const level& y) {
        return (c * x.first + v * x.second) < (c * y.first + v * y.second);
    });

    dp[0].set(0, true);
    for (level& lvl : a) {
        int start = min((v * lvl.second + c - 1) / c - 1, tot - lvl.first);
        shift(start, lvl.first);
    }

    int ans = get_last();
    ans = tot + (c - 1) * ans;

    cout << ans << '\n';

    return 0;
}
