// TODO: needs a bitset optimisation

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using word = unsigned int;
static constexpr int WORD_BITS = CHAR_BIT * sizeof(word);

struct quest
{
    ll xp;
    ll d;

    bool operator<(const quest &other) const
    {
        return xp + d < other.xp + other.d;
    }
};

class mybitset
{
private:
    size_t size;
    vector<word> bits;

public:
    explicit mybitset(size_t size = 0) : size(size), bits(size / WORD_BITS + 1) {}

    bool operator[](size_t idx) const
    {
        assert(idx < size);
        return (bits[idx / WORD_BITS] >> (idx % WORD_BITS)) & 1;
    }

    void set(size_t idx)
    {
        assert(idx < size);
        bits[idx / WORD_BITS] |= 1 << (idx % WORD_BITS);
    }

    // Shift bottom `clip` bits left by `dist`
    mybitset shl_clip(size_t dist, size_t clip) const
    {
        mybitset out(size);
        if (dist >= size)
            return out;
        clip = min(clip, size - dist);
        // TODO: optimise
        for (size_t i = 0; i < clip; i++)
            if ((*this)[i])
                out.set(i + dist);
        return out;
    }

    mybitset &operator|=(const mybitset &other)
    {
        assert(size == other.size);
        for (size_t i = 0; i < bits.size(); i++)
            bits[i] |= other.bits[i];
        return *this;
    }

    int top_bit() const
    {
        for (int i = int(bits.size()) - 1; i >= 0; i--)
        {
            if (bits[i] != 0)
            {
                for (int j = WORD_BITS - 1; j >= 0; j--)
                    if ((bits[i] >> j) & 1)
                        return i * WORD_BITS + j;
            }
        }
        return -1;
    }
};

int main()
{
    ios::sync_with_stdio(false);
    int N;
    ll V, C, sum_xp = 0;
    cin >> N >> V >> C;
    vector<quest> quests(N);
    for (int i = 0; i < N; i++)
    {
        ll d;
        cin >> quests[i].xp >> d;
        // min x such that x * C / V >= d
        // x * C >= d * V
        quests[i].d = (d * V + C - 1) / C;
        sum_xp += quests[i].xp;
    }
    sort(quests.begin(), quests.end());

    mybitset knap(sum_xp + 1);
    knap.set(0);
    for (const quest &q : quests)
    {
        knap |= knap.shl_clip(q.xp, q.d);
    }
    ll best = knap.top_bit();
    ll score = best * (C - 1) + sum_xp;
    cout << score << '\n';
}
