#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

static constexpr int BS_SIZE = 4000008;

struct quest
{
    ll xp;
    ll d;

    bool operator<(const quest &other) const
    {
        return xp + d < other.xp + other.d;
    }
};

int main()
{
    ios::sync_with_stdio(false);

    int N;
    ll V, C, sum_xp = 0;
    cin >> N >> V >> C;
    vector<quest> quests(N);
    for (int i = 0; i < N; i++)
    {
        ll d;
        cin >> quests[i].xp >> d;
        // min x such that x * C / V >= d
        // x * C >= d * V
        quests[i].d = (d * V + C - 1) / C;
        sum_xp += quests[i].xp;
    }
    sort(quests.begin(), quests.end());

    bitset<BS_SIZE> knap;
    knap.set(0);
    for (const quest &q : quests)
    {
        // shift bottom q.d bits left by q.xp
        bitset<BS_SIZE> sub = knap;
        if (q.d < BS_SIZE)
        {
            sub <<= BS_SIZE - q.d;
            sub >>= BS_SIZE - q.d;
        }
        knap |= sub << q.xp;
    }
    ll best = BS_SIZE - 1;
    while (!knap[best])
        best--;
    ll score = best * (C - 1) + sum_xp;
    cout << score << '\n';
}
