#include <algorithm>
#include <iostream>
#include <set>
#include <vector>
#include <utility>

using namespace std;

using level = pair<int, int>;
constexpr int LOOKBACK = 2000;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, v, c;
    cin >> n >> v >> c;

    int tot = 0;
    // exp, target level
    vector<level> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;

        tot += a[i].first;
    }

    // sort by deadlines - max exp you can have _after_ completion
    sort(begin(a), end(a), [&](const level& x, const level& y) {
        return (c * x.first + v * x.second) < (c * y.first + v * y.second);
    });

    set<int> dp = {0};
    for (level& lvl : a) {
        set<int> new_dp;
        // c * x < v * lvl.second
        // x < (v * lvl.second) / c
        int goal = (v * lvl.second + c - 1) / c;
        auto it = dp.lower_bound(goal);

        if (it != begin(dp)) it = prev(it);
        while (it != begin(dp) and new_dp.size() < LOOKBACK) {
            new_dp.insert(*it + lvl.first);
            it = prev(it);
        }

        for (int x : new_dp) {
            dp.insert(x);
        }

        dp.insert(lvl.first);
    }

    int ans = *prev(end(dp));
    ans = tot + (c - 1) * ans;

    cout << ans << '\n';

    return 0;
}
