#include <algorithm>
#include <iostream>
#include <set>
#include <vector>
#include <utility>

using namespace std;

using level = pair<int, int>;

constexpr int INF = 1e9;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, v, c;
    cin >> n >> v >> c;

    int tot = 0;
    // exp, target level
    vector<level> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;

        tot += a[i].first;
    }

    // sort by deadlines - max exp you can have _after_ completion
    sort(begin(a), end(a), [&](const level& x, const level& y) {
        return (c * x.first + v * x.second) < (c * y.first + v * y.second);
    });

    // dp[i][j] = max XP by using j of the first i
    vector<int> dp(n + 1, -INF);
    dp[0] = 0;
    for (level& lvl : a) {
        vector<int> new_dp(begin(dp), end(dp));
        for (int i = 0; i < n; ++i) {
            if (dp[i] < 0) break;
            if (c * dp[i] < v * lvl.second) {
                new_dp[i + 1] = max(new_dp[i + 1], dp[i] + lvl.first);
            }
        }

        swap(dp, new_dp);
    }

    int ans = *max_element(begin(dp), end(dp));
    ans = tot + (c - 1) * ans;

    cout << ans << '\n';

    return 0;
}
