#include <bits/stdc++.h>

using namespace std;

struct edge
{
    int trg;
    int dist;
    int id;
};

struct node
{
    vector<edge> edges;
};

static vector<node> nodes;

static int route(int a, int b, int parent, vector<bool> &used, const vector<bool> &avoid)
{
    if (a == b)
        return 0;
    for (const edge &e : nodes[a].edges)
    {
        if (e.trg == parent || avoid[e.id])
            continue;
        int d = route(e.trg, b, a, used, avoid);
        if (d >= 0)
        {
            used[e.id] = true;
            return d + e.dist;
        }
    }
    return -1;
}


int main()
{
    int N;
    cin >> N;
    nodes.resize(N);
    int tdist = 0;
    for (int i = 0; i < N - 1; i++)
    {
        int u, v, d;
        cin >> u >> v >> d;
        u--;
        v--;
        nodes[u].edges.push_back(edge{v, d, i});
        nodes[v].edges.push_back(edge{u, d, i});
        tdist += d;
    }

    int best = 0;
    for (int a = 0; a < N; a++)
        for (int c = a + 1; c < N; c++)
        {
            vector<bool> avoid(N - 1);
            int d1 = route(a, c, -1, avoid, avoid);
            for (int b = 0; b < N; b++)
                for (int d = b + 1; d < N; d++)
                {
                    vector<bool> used(N - 1);
                    int d2 = route(b, d, -1, used, avoid);
                    if (d2 >= 0 && d1 + d2 > best)
                        best = d1 + d2;
                }
        }
    int ans = 2 * tdist - best;
    cout << ans <<'\n';

    return 0;
}
