#include <algorithm>
#include <functional>
#include <iostream>
#include <vector>
using namespace std;

int N, K;
vector<vector<pair<int, int>>> g;

vector<vector<vector<int>>> partitions{{{}}, {{1}}};

vector<int> doit(int x, int prev) {
  vector<vector<pair<int, int>>> best(K+1);
  for (auto [y, d] : g[x]) if (y != prev) {
    auto v = doit(y, x);
    for (int i = 1; i <= K; i++) best[i].push_back({v[i] + (i%2 ? d : 0), y});
  }
  for (int i = 1; i <= K; i++) {
    sort(best[i].begin(), best[i].end(), greater<pair<int, int>>());
  }

  vector<int> ret(K+1);
  for (int i = 1; i <= K; i++) {
    for (auto const& part : partitions[i]) {
      vector<int> seen, idx(K+1);
      int cur = 0;
      for (auto x : part) {
        for (; idx[x] < best[x].size(); idx[x]++) {
          auto [value, nd] = best[x][idx[x]];
          if (find(seen.begin(), seen.end(), nd) == seen.end()) {
            seen.push_back(nd);
            cur += value;
            break;
          }
        }
      }
      ret[i] = max(ret[i], cur);
    }
  }
  return ret;
}

int main() {
  partitions.resize(11);
  for (int i = 2; i <= 10; i++) {
    for (auto const& part : partitions[i-1]) {
      partitions[i].push_back(part);
      partitions[i].back().back()++;
      partitions[i].push_back(part);
      partitions[i].back().push_back(1);
    }
  }

  while (cin >> N >> K) {
    K *= 2;
    int ret = 0;
    g.clear();
    g.resize(N+1);
    for (int i = 0; i < N-1; i++) {
      int A, B, D;
      cin >> A >> B >> D;
      g[A].push_back({B, D});
      g[B].push_back({A, D});
      ret += D*2;
    }
    cout << ret - doit(rand()%N+1, 0)[K] << endl;
  }
}
