#include <cstdlib>
#include <ctime>
#include <iostream>
#include <string>
#include <vector>
using namespace std;

int dx[6] = {1, -1, 0, 0, 0, 0};
int dy[6] = {0, 0, 1, -1, 0, 0};
int dz[6] = {0, 0, 0, 0, 1, -1};
string ds[6] = {"x+", "x-", "y+", "y-", "z+", "z-"};

int main(int argc, char *argv[]) {
  srand(time(0));

  cerr << "Usage: gen [max lower vertex] [max cube size]" << endl;
  int maxc = 1000, maxs = 100;
  if (argc > 1) maxc = atoi(argv[1]);
  if (argc > 2) maxs = atoi(argv[2]);

  cout << "100 100" << endl;
  vector<int> ax, ay, az, bx, by, bz;
  for (int i = 0; i < 100; i++) {
    int x1 = rand()%maxc, x2 = x1 + rand()%maxs+1;
    int y1 = rand()%maxc, y2 = y1 + rand()%maxs+1;
    int z1 = rand()%maxc, z2 = z1 + rand()%maxs+1;
    ax.push_back(x1); bx.push_back(x2);
    ay.push_back(y1); by.push_back(y2);
    az.push_back(z1); bz.push_back(z2);
    cout << x1 << ' ' << y1 << ' ' << z1 << ' ' << x2 << ' ' << y2 << ' ' << z2 << endl;
  }

  for (int i = 0; i < 100; i++) {
    int n = rand()%100;
    int x = (rand()%(bx[n]-ax[n])+ax[n]);
    int y = (rand()%(by[n]-ay[n])+ay[n]);
    int z = (rand()%(bz[n]-az[n])+az[n]);
    int d = rand()%6;
    for (;;) {
      bool v1 = false, v2 = false;
      for (int j = 0; j < 100; j++) {
        if (x >= ax[j] && x < bx[j] &&
            y >= ay[j] && y < by[j] &&
            z >= az[j] && z < bz[j]) {
          v1 = true;
        }
        if (x+dx[d] >= ax[j] && x+dx[d] < bx[j] &&
            y+dy[d] >= ay[j] && y+dy[d] < by[j] &&
            z+dz[d] >= az[j] && z+dz[d] < bz[j]) {
          v2 = true;
        }
      }
      if (v1 && !v2) break;
      x += dx[d]; y += dy[d]; z += dz[d];
    }
    int d2;
    do {
      d2 = rand()%6;
    } while (d == d2 || d == (d2^1));
    cout << x << ' ' << y << ' ' << z << ' ' << ds[d] << ' ' << ds[d2] << endl;
  }
}
