#!/usr/bin/env python3

# Just checks that robots start on faces of the cubes. Assumes that
# bmerry-format.ctd has validated the formatting.

import sys

def inside(cubes, x, y, z):
    for x1, y1, z1, x2, y2, z2 in cubes:
        if x1 <= x < x2 and y1 <= y < y2 and z1 <= z < z2:
            return True
    return False

def step(x, y, z, d):
    a = 1 if d[1] == '+' else -1
    if d[0] == 'x':
        return x + a, y, z
    elif d[0] == 'y':
        return x, y + a, z
    else:
        return x, y, z + a

def main():
    n, k = [int(x) for x in sys.stdin.readline().split()]
    cubes = []
    for i in range(n):
        cubes.append([int(x) for x in sys.stdin.readline().split()])
    for i in range(k):
        x, y, z, f, d = sys.stdin.readline().split()
        x = int(x); y = int(y); z = int(z)
        assert inside(cubes, x, y, z)
        xo, yo, zo = step(x, y, z, f)
        assert not inside(cubes, xo, yo, zo)
    sys.exit(42)

if __name__ == '__main__':
    main()
