
/* Visualization tool for Space Walls (still a work in progress). */

//settings.prc = false;
size(5cm,0);
import three;

draw(-0.6X -- 10X, linewidth(0.2pt), arrow=Arrow3(TeXHead2), L=Label(scale(0.3)*"$x$", position=EndPoint, linewidth(0.5)));
draw(-0.6Y -- 10Y, linewidth(0.2pt), arrow=Arrow3(TeXHead2), L=Label(scale(0.3)*"$y$", position=EndPoint));
draw(-0.6Z -- 25Z, linewidth(0.2pt), arrow=Arrow3(TeXHead2,2), L=Label(scale(0.8)*"$z$", position=EndPoint));

void onecube(int x1, int y1, int z1, int x2, int y2, int z2) {
		draw(box((x1,y1,z1), (x2,y2,z2)),blue+linewidth(0.8pt));
		draw(shift(x1,y1,z1) * scale(x2-x1,y2-y1,z2-z1) * unitcube, lightgray + opacity(0.5));
}

int n = stdin, k = stdin;


for (int i = 0; i < n; ++i) {
	int x1 = stdin, y1 = stdin, z1 = stdin, x2 = stdin, y2 = stdin, z2 = stdin;
	onecube(x1,y1,z1, x2,y2,z2);
}

pen[] cols = {red, green, blue, yellow, orange, magenta};
for (int i = 0; i < k; ++i) {
	real x = (real)stdin + 0.5, y = (real)stdin + 0.5, z = (real)stdin + 0.5;
	string fd = stdin;
	string f = split(fd)[0], d = split(fd)[1];
	pen c = cols[i % cols.length];
	if (f == "x+") x += 0.5;
	if (f == "x-") x -= 0.5;
	if (f == "y+") y += 0.5;
	if (f == "y-") y -= 0.5;
	if (f == "z+") z += 0.5;
	if (f == "z-") z -= 0.5;
	draw(shift(x,y,z)*scale(0.4,0.4,0.4)*unitsphere, c, nolight);
	real xd=x, yd=y, zd=z, alen=1.5;
	if (d == "x+") xd += alen;
	if (d == "x-") xd -= alen;
	if (d == "y+") yd += alen;
	if (d == "y-") yd -= alen;
	if (d == "z+") zd += alen;
	if (d == "z-") zd -= alen;
	draw((x,y,z)--(xd,yd,zd), c+linewidth(0.3), arrow=Arrow3(9, emissive(c)));
}

