#!/usr/bin/env python3
# Checks that the graph forms a tree, assuming syntax.ctd has already passed

import sys

n, c = [int(x) for x in sys.stdin.readline().split()]
edges = [[] for i in range(n)]
for i in range(n - 1):
    u, v, s = [int(x) for x in sys.stdin.readline().split()]
    u -= 1
    v -= 1
    edges[u].append(v)
    edges[v].append(u)

seen = [False] * n
st = [0]
seen[0] = True
while st:
    cur = st.pop()
    for y in edges[cur]:
        if not seen[y]:
            seen[y] = True
            st.append(y)
if not all(seen):
    print('Graph is not a tree', file=sys.stderr)
    sys.exit(1)
else:
    sys.exit(42)
