
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

/**
 * ICPC World Finals 2020
 * Incorrect Solution: Speed Limit Signs
 * <p>
 * WRONG ANSWER
 * 
 * @author Martin Kacer
 */
public class SpeedLimitOldMK {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() {
		while (!st.hasMoreTokens()) try {
			String line = input.readLine();
			if (line == null) return false;
			st = new StringTokenizer(line);
		} catch (Exception ex) { throw new RuntimeException(ex); }
		return true;
	}
	String nextToken() {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	public static void main(String[] args) throws Exception {
		new SpeedLimitOldMK().run();
	}
	
	static class Node {
		final int idx;
		final ArrayList<Edge> edges = new ArrayList<>();
		public Node(int idx) { this.idx = idx; }
		@Override public String toString() { return "N#"+(idx+1); }
	}
	static class Edge {
		final Node node;
		final int speed;
		Edge(Node node, int speed) { this.node = node; this.speed = speed; }
		@Override public String toString() { return "E->"+node+"("+speed+")"; }
	}
	Node[] graph;
	int n, cost;
	
	void run() {
		n = nextInt(); cost = nextInt();
		graph = new Node[n];
		for (int i = 0; i < n; ++i) graph[i] = new Node(i);
		for (int i = 1; i < n; ++i) {
			int u = nextInt()-1, v = nextInt()-1, s = nextInt();
			graph[u].edges.add(new Edge(graph[v], s));
			graph[v].edges.add(new Edge(graph[u], s));
		}
		System.out.println(solve(new Edge(graph[0], -1), null).bestCost());
	}

	/** The recursive step -- combine results of subtrees. */
	SubResult solve(Edge ep, Node parent) {
		ArrayList<SubResult> subs = new ArrayList<>(ep.node.edges.size());
		int max = 0; long sum = 0;
		for (Edge e : ep.node.edges) {
			max = Math.max(max, e.speed);
			if (e.node == parent) continue;
			SubResult r = solve(e, ep.node);
			subs.add(r);
			sum += r.bestCost();
		}
		SubResult res = new SubResult(ep, sum);
		// gradually increase the speed and find next segments of the resulting function
		for (int s = max; s < Integer.MAX_VALUE-1; ) {
			long sc = 0; int sm = 0;
			for (SubResult sr : subs) {
				sc += sr.costFor(s) + (s - sr.inc.speed);
				sm += sr.marginalCost() + 1; // plus 1 for the incoming edge itself
			}
			res.addSegment(s, sc, sm);
			final int sf0 = s + 1;
			s = subs.stream().mapToInt(it -> it.nextSpeed(sf0)).reduce(Integer.MAX_VALUE-1, Integer::min);
		}
		System.err.println(ep.node + " -> " + res);
		return res;
	}

	
	/**
	 * Description of the subtree result, which is basically a function
	 * mapping a speed limit of an incoming edge ("uplink" edge) to the best possible solution
	 * of the whole subtree.
	 * The function is piecewise linear, consisting of left-closed right-open intervals.
	 */
	class SubResult {
		final Edge inc;
		final int deg;
		final long unbal;
		final ArrayList<Integer> si = new ArrayList<>(), mi = new ArrayList<>();
		final ArrayList<Long> ci = new ArrayList<>();
		int idx = 0;
		SubResult(Edge edge, long sum) { this.inc = edge; this.deg = edge.node.edges.size(); this.unbal = sum + deg * cost; }
		
		/** The left end of the next interval.
		 * @return the next "interesting" point of the result function greater or equal to "min".
		 */
		int nextSpeed(int min) {
			while (idx < si.size() && min > si.get(idx)) ++idx;
			return (idx < si.size()) ? si.get(idx) : Integer.MAX_VALUE;
		}
		
		/** Basic cost for a given speed.
		 * @param speed speed of an "incoming edge" (the one from the node's parent).
		 *   Must not be less than the current linear segment.
		 * @return the best cost achievable with the given incoming edge speed, counting the whole subtree.
		 *   The cost may represent both balanced or unbalanced node, whichever is cheaper.
		 *   If the node is unbalanced, the cost will include the installation of all speed-limit
		 *   signs, including the bottom end of the incoming ("uplink") edge (only if there is any!).
		 *   However, note that the cost does NOT include the cost of upgrading the incoming edge.
		 */
		long costFor(int speed) {
			nextSpeed(speed+1);
			if (idx == 0) return unbal;
			return ci.get(idx-1) + (speed - si.get(idx-1)) * mi.get(idx-1);
		}
		
		/** Slope of the current linear segment.
		 * @return the "marginal cost" of increasing the incoming edge speed by 1 more km/h. 
		 *   The value corresponds to the last value returned by {@link #costFor}.
		 *   As for {@link #costFor}, the marginal cost does NOT include the incoming edge upgrade.
		 */
		int marginalCost() {
			if (idx == 0) return 0;
			return (idx < si.size()) ? mi.get(idx-1) : 0;
		}
		
		/** The best cost achievable for the whole subtree, without any limitation on the incoming edge.
		 * The result may or may not include the price of the 
		 */
		long bestCost() {
			long best = unbal;
			for (int i = 0; i < ci.size(); ++i)
				// TODO: !!!TEST 1) kill if the condition is missing, 2) whether it works this way at all
				best = Math.min(best, ci.get(i) + (inc.speed < 0 ? 0 : si.get(i) - inc.speed));
			return best;
		}
		
		/** Add a new linear segment to an already-existing function.
		 * This may only be invoked before the other (reading) methods. */
		void addSegment(int speed, long cost, int marg) {
			if (si.size() > 0 && si.get(si.size()-1) >= speed) {
				si.remove(si.size()-1); ci.remove(ci.size()-1); mi.remove(mi.size()-1);
			}
			if (marg == 0) { doAdd(speed, cost, 0); return; }
			long sd = (unbal - cost + marg-1) / marg;
			if (sd <= 0) doAdd(speed, unbal, 0);
			else {
				doAdd(speed, cost, marg);
				doAdd(speed + (int) sd, unbal, 0);
			}
		}
		private void doAdd(int speed, long cost, int marg) { si.add(speed); ci.add(cost); mi.add(marg); }
		@Override public String toString() { return "SubResult/unbal="+unbal+si+ci+mi+"=>"+bestCost(); }
	}
}
