
import sys

INF = 2000000000

class Node:
	def __init__(self, idx):
		self.edges = []
		self.idx = idx


class Edge:
	def __init__(self, node, speed):
		self.node = node
		self.speed = speed


class SubResult:

	def __init__(self, deg, inc, sum):
		self.si, self.mi, self.ci = [], [], []
		self.deg, self.inc = deg, inc
		self.unbal = sum + deg * costsign
		self.idx = 0
	
	def cost_for(self, speed):
		while self.idx < len(self.si) and speed >= self.si[self.idx]:
			self.idx += 1
		if self.idx == 0:
			return self.unbal
		return self.ci[self.idx-1] + (speed - self.si[self.idx-1]) * self.mi[self.idx-1]

	def marg_cost(self):
		return 0 if self.idx == 0 else self.mi[self.idx-1]
	
	def next_speed(self):
		return self.si[self.idx] if self.idx < len(self.si) else INF

	def best_cost(self):
		best = self.unbal
		for i in range(len(self.ci)):
			best = min(best, self.ci[i] + (0 if not self.inc else self.si[i] - self.inc.speed))
		return best
	
	def add_segment(self, speed, cost, marg):
		if self.si and self.si[-1] >= speed:
			del self.si[-1:]
			del self.ci[-1:]
			del self.mi[-1:]
		if (marg == 0):
			self.do_add(speed, cost, 0)
			return
		sd = (self.unbal - cost + marg-1) // marg
		if sd <= 0:
			self.do_add(speed, self.unbal, 0)
		else:
			self.do_add(speed, cost, marg)
			self.do_add(speed + sd, self.unbal, 0)
			
	def do_add(self, speed, cost, marg):
		self.si.append(speed)
		self.ci.append(cost)
		self.mi.append(marg)


def solve(cur, inc, parent):
	subs = []
	mx, sum = 0, 0
	for e in cur.edges:
		mx = max(mx, e.speed)
		if (e.node == parent):
			continue
		r = solve(e.node, e, cur)
		subs.append(r)
		sum += r.best_cost()

	myres = SubResult(len(cur.edges), inc, sum)
	s = mx
	while s < INF:
		sc, sm = 0, 0
		for sr in subs:
			sc += sr.cost_for(s) + (s - sr.inc.speed)
			sm += sr.marg_cost() + 1
		myres.add_segment(s, sc, sm)
		s = min([INF] + [it.next_speed() for it in subs])

	return myres


sys.setrecursionlimit(25000)

n, costsign = [int(f) for f in sys.stdin.readline().split()]
graph = [Node(i) for i in range(n+1)]
for _ in range(n-1):
	u, v, s = [int(f) for f in sys.stdin.readline().split()]
	graph[u].edges.append(Edge(graph[v], s))
	graph[v].edges.append(Edge(graph[u], s))

print(solve(graph[1], None, None).best_cost())

