/* Greedy solution: keeps trying to toggle upgradability until it reaches
 * a local minimum.
 *
 * It's not a particularly efficient implementation. It's defined for finding
 * small test cases that break.
 */

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct edge
{
    int trg;
    ll cost;

    edge() = default;
    edge(int trg, ll cost) : trg(trg), cost(cost) {}
};

struct node
{
    ll sum = 0;
    ll top = 0;
    vector<edge> edges;
};

static ll evaluate(const vector<node> &nodes, ll C, const vector<bool> &upgrade)
{
    int N = nodes.size();
    ll score = 0;
    vector<bool> seen(N);
    for (int i = 0; i < N; i++)
    {
        if (!upgrade[i])
            score += nodes[i].edges.size() * C;
        else if (!seen[i])
        {
            stack<int> st;
            st.push(i);
            seen[i] = true;
            ll sum = 0;
            ll top = 0;
            int E = 1;
            while (!st.empty())
            {
                int cur = st.top();
                st.pop();
                E += nodes[cur].edges.size() - 1;
                sum += nodes[cur].sum;
                top = max(top, nodes[cur].top);
                for (const auto &e : nodes[cur].edges)
                {
                    int y = e.trg;
                    if (!seen[y] && upgrade[y])
                    {
                        seen[y] = true;
                        st.push(y);
                        sum -= e.cost;
                    }
                }
            }
            score += top * E - sum;
        }
    }
    return score;
}

int main()
{
    int N, C;
    cin >> N >> C;
    vector<node> nodes(N);

    auto add = [&](int u, int v, ll s)
    {
        node &n = nodes[u];
        n.sum += s;
        n.top = max(n.top, s);
        n.edges.emplace_back(v, s);
    };

    for (int i = 0; i < N - 1; i++)
    {
        int u, v;
        ll s;
        cin >> u >> v >> s;
        u--;
        v--;
        add(u, v, s);
        add(v, u, s);
    }

    bool more = true;
    vector<bool> upgrade(N);
    ll score = evaluate(nodes, C, upgrade);
    while (more)
    {
        more = false;
        for (int i = 0; i < N; i++)
        {
            upgrade[i] = !upgrade[i];
            ll new_score = evaluate(nodes, C, upgrade);
            if (new_score < score)
            {
                score = new_score;
                more = true;
            }
            else
                upgrade[i] = !upgrade[i];
        }
    }
    cout << score << '\n';
}
