#!/usr/bin/env python

import argparse
import graphviz

parser = argparse.ArgumentParser()
parser.add_argument('input')
parser.add_argument('output')
args = parser.parse_args()

with open(args.input) as inf:
    n, c = [int(x) for x in inf.readline().split()]
    dot = graphviz.Graph()
    if n <= 1000:
        dot.attr(label='c = {}'.format(c))
        for i in range(n):
            dot.node(str(i + 1), str(i + 1))
        for i in range(n - 1):
            u, v, s = [int(x) for x in inf.readline().split()]
            dot.edge(str(u), str(v), label='{}'.format(s))
    else:
        dot.attr(label='n = {}, c = {}'.format(n, c))
data = dot.pipe(format='png')
with open(args.output, 'wb') as outf:
    outf.write(data)
