import sys

with open(sys.argv[1], "r") as source_file:
  source = [float(x) for x in source_file.read().split()]

with open(sys.argv[2], "r") as target_file:
  target = [float(x) for x in target_file.read().split()]

assert (len(source) == len(target))

ok = True

first_error = None
error_size = None

for i, (s, t) in enumerate(zip(source, target)):
  if abs(s - t) > 1e-8:
    if not first_error or abs(s - t) > error_size:
      first_error = "Comparing index {}: {} vs {} ({} diff)".format(i, s, t, abs(s-t))
      error_size = abs(s - t)
    ok = False

if not ok:
  print "Comparison failed: " + first_error
  sys.exit(1)
  
