#include <bits/stdc++.h>

using namespace std;

using real_t = long double;

static vector<real_t> probs(const vector<real_t> &p)
{
    int N = p.size();
    vector<real_t> dp(N + 1);
    vector<real_t> dp2(N + 1);
    dp[0] = 1;
    for (int i = 0; i < N; i++)
    {
        real_t q = p[i];
        real_t r = 1 - q;
        dp2[0] = dp[0] * r;
        for (int j = 1; j <= i; j++)
            dp2[j] = dp[j - 1] * q + dp[j] * r;
        dp2[i + 1] = dp[i] * q;
        dp2.swap(dp);
    }
    return dp;
}

int main()
{
    ios::sync_with_stdio(false);
    int R, C, T, Q;
    cin >> R >> C >> T >> Q;
    vector<real_t> pr(R), qc(C);
    for (int i = 0; i < R; i++)
        cin >> pr[i];
    for (int i = 0; i < C; i++)
        cin >> qc[i];

    int N = R * C;
    vector<real_t> p(N);
    for (int i = 0; i < R; i++)
        for (int j = 0; j < C; j++)
            p[i * C + j] = pr[i] + qc[j];
    real_t norm = 1 / probs(p)[T];

    cout << fixed << setprecision(12);
    for (int i = 0; i < Q; i++)
    {
        vector<bool> inc(N);
        int S;
        cin >> S;
        for (int j = 0; j < S; j++)
        {
            int r, c;
            cin >> r >> c;
            r--;
            c--;
            inc[r * C + c] = true;
        }
        vector<real_t> inside, outside;
        for (int j = 0; j < N; j++)
            (inc[j] ? inside : outside).push_back(p[j]);
        auto inside_p = probs(inside);
        auto outside_p = probs(outside);
        for (int j = 0; j <= S; j++)
        {
            int r = T - j;
            real_t ans = (r >= 0 && r < int(outside_p.size()))
                ? outside_p[r] * inside_p[j] * norm : 0;
            cout << ans << ' ';
        }
        cout << '\n';
    }
}
