import random

# NOTE: Run from the _root_ of the problem directory, not in the generators folder

DIGITS = "0123456789"
NONZERO = DIGITS[1:]

MAXLOGA = 10000
MAXB = 1000000


def main():
    random.seed("wf2020")

    cases = []
    a = "".join([random.choice(NONZERO)] + random.choices(DIGITS, k=MAXLOGA - 1))

    for b, d in [
        (583764, 4),
        (583764, 2),
        (583764, 0),
        (128, 2),
        (128, 0),
        (128, 8),
        (3, 3),
        (2, 2),
    ]:
        cases.append((b, d, a))

    cases.append((1, 1, "1"))
    cases.append((1, 2, "1"))
    cases.append((999999, 1, "999999"))
    cases.append((999999, 0, "999999"))
    cases.append((333333, 9, "9" * (MAXLOGA - 1)))
    cases.append((333333, 9, "9" * (MAXLOGA - 2) + "8"))
    cases.append((44, 3, "615164488012970354555742215744"))

    for b in [1 << 3, 1 << 18]:
        for d in [0, 2, 4, 6, 8]:
            cases.append((b, d, "9999999999999999999"))

    for d in [0, 5]:
        for a in ["1000", "10000", "10000000000"]:
            cases.append((625, d, a))

    for _ in range(7):
        b = random.choice(range(1, MAXB, 2))
        d = random.choice(range(10))
        a = "".join([random.choice(NONZERO)] + random.choices(DIGITS, k=29))

        cases.append((b, d, a))

    for _ in range(3):
        b = 16 * random.randint(1, MAXB // 16) + 8
        a = "".join([random.choice(NONZERO)] + random.choices(DIGITS, k=MAXLOGA - 1))
        assert b % 16 == 8 and b % 5 != 0
        cases.append((b, 8, a))

    for _ in range(3):
        b = 10 * random.randint(1, MAXB // 10) + 5
        a = "".join([random.choice(NONZERO)] + random.choices(DIGITS, k=MAXLOGA - 1))
        assert b % 10 == 5
        cases.append((b, 5, a))

    for idx, case in enumerate(cases, start=1):
        b, d, a = case
        with open(f"data/secret/{idx:02d}.in", "w") as out_file:
            out_file.write(f"{b} {d} {a}\n")

if __name__ == "__main__":
    main()
