#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T> static constexpr T wrap_pos(T a, T m) { return a < 0 ? a + m : a; }
template<typename T> static constexpr T mod(T a, T m) { return wrap_pos(a % m, m); }
template<typename T> static constexpr T gcd(T a, T b) { return b ? gcd(b, a % b) : a; }
template<typename T>
static constexpr T inverse2(T a, T m) { return a <= 1 ? a : mod((1 - inverse2(m % a, a) * m) / a, m); }

// a must be relatively prime to m, m > 0
template<typename T>
static constexpr T inverse(T a, T m) { return inverse2(mod(a, m), m); }

/* Solves ax = b mod m, returning smallest x, or -1 if not solvable
 * (smallest strictly positive, if allow_zero is false).
 * Must have 0 <= a, b < m.
 */
static ll solve_linear(ll a, ll b, ll m, bool allow_zero)
{
    ll g = gcd(a, m);
    if (b % g != 0)
        return -1;
    a /= g;
    b /= g;
    m /= g;
    ll ans = (a == 0) ? 0 : b * inverse(a, m) % m;
    if (ans == 0 && !allow_zero)
        ans += m;
    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    ll b;
    string a;
    ll d;
    cin >> b >> d >> a;
    ll s = 0;
    ll p10 = 1;
    ll t = 0;
    // Note: could significantly reduce runtime by using binary search
    for (t = 0; ; t++)
    {
        /* b | s + x * p10
         * x * p10 = -s mod b
         */
        ll x = solve_linear(p10, mod(-s, b), b, t > 0 && d > 0);
        if (x == -1)
            break;
        string xs = x ? to_string(x) : "";
        auto L = xs.size() + t;
        if (L > a.size())
            break;
        else if (L == a.size())
        {
            string bundle = xs + string(t, '0' + d);
            if (bundle > a)
                break;
        }
        s = (s * 10 + d) % b;
        p10 = p10 * 10 % b;
    }
    cout << t - 1 << '\n';
}
