#include <bits/stdc++.h>

using namespace std;

int b, d;
string a;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> b >> d >> a;
    int n = a.size();

    vector<int> p10(n + 1);
    p10[0] = 1;
    for (int i = 1; i <= n; ++i) {
        p10[i] = (10 * p10[i - 1]) % b;
    }

    vector<int> tails(n + 1);
    tails[0] = 0;
    tails[1] = d % b;
    for (int i = 2; i <= n; ++i) {
        tails[i] = (10 * tails[i - 1] + d) % b;
    }

    // Starting from pos, can you make a tail of ddddddd?
    vector<bool> can_tail(n + 1);
    can_tail[n] = true;
    for (int i = n - 1; i >= 0; --i) {
        if (a[i] == d + '0') {
            can_tail[i] = can_tail[i + 1];
        } else if (a[i] > d + '0') {
            can_tail[i] = true;
        }
    }

    // dp[digit pos][mod][under a][non zero]
    vector<vector<vector<int>>> dp(n, vector<vector<int>>(b, vector<int>(4, -1)));

    // manual y-combinator
    auto solve = [&](auto self, auto& dp, int pos, int val, bool less, bool nonzero) -> int {
        if (pos >= n) return 0;

        // memoization
        int& res = dp[pos][val][2 * less + nonzero];
        if (res != -1)
            return res;

        res = 0;
        int rem_digs = n - pos;
        if ((less or can_tail[pos]) and (val + tails[rem_digs]) % b == 0) {
            if (d > 0 or nonzero)
                res = rem_digs;
        }

        for (int dig = 0; dig < 10 and (less or (dig + '0') <= a[pos]); ++dig) {
            int new_val = (val + dig * p10[n - pos - 1]) % b;
            res = max(res, self(
                        self,
                        dp,
                        pos + 1,
                        new_val,
                        less or (dig + '0') < a[pos],
                        nonzero or dig > 0));
        }

        return res;
    };

    cout << solve(solve, dp, 0, 0, false, false) << '\n';
}
