import java.util.*;
import java.io.*;

public class TrailingDigits {

	public static void main(String[] args) {

		int digit, b, b0, b1, b2;
		String max;
		ArrayList<Multiplicand> multiplicands = new ArrayList<>();
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in)); 

		StringTokenizer st = null;
		try {
			st = new StringTokenizer(in.readLine()); 
		}
		catch (IOException e) {
			System.out.println(e);
			System.exit(-1);
		}
		b = Integer.parseInt(st.nextToken()); 
		digit = Integer.parseInt(st.nextToken());
		max = st.nextToken();
		int totalDigits = max.length();

		multiplicands.add(new Multiplicand(0, 0, false));
		int i=0;
		do {
			Multiplicand m = multiplicands.remove(0);
			i = m.numTarget;
			if (i >= totalDigits-5) {
				multiplicands.add(0, m);
				break;
			}
			for(int d=0; d<=9; d++) {
				int val = d*b + m.digits;
				if (val%10 == digit) {
					int maxDigit = max.charAt(max.length()-1-i) - '0';	// corresponding digit in max
					if (i == 0)
						multiplicands.add(new Multiplicand(val/10, m.numTarget+1, digit > maxDigit));
					else
						multiplicands.add(new Multiplicand(val/10, m.numTarget+1, m.greaterThan && (digit >= maxDigit)));
				}
			}
		} while (multiplicands.size() > 0);
		// just do adds for the remaining digits
		int best = i;
		int upperVal;
		if (totalDigits >= 5)
			upperVal = Integer.parseInt(max.substring(0, 5));
		else
			upperVal = Integer.parseInt(max);
		for(Multiplicand m : multiplicands) {
			int val = m.digits;
			int limit = upperVal;
			if (m.greaterThan)
				limit--;
			while (val <= limit) {
				int count = m.numTarget;
				if (val != 0 && val%10 == digit) {
					count++;
					if (val >= 10 && (val/10)%10 == digit) {
						count++;
						if (val >= 100 && (val/100)%10 == digit) {
							count++;
							if (val >= 1000 && (val/1000)%10 == digit) {
								count++;
								if (val >= 10000 && (val/10000)%10 == digit)
									count++;
							}
						}
					}
					if (count > best) {
						best = count;
//						System.out.println(best + " " + val + " " + m.greaterThan);
					}
				}
				val += b;
			}
		}
		System.out.println(best);
		//		}
	}
}

class Multiplicand
{
	public int digits;			// first three digits of multiplicand
	public int numTarget; 		// number of target digits produced by this multiplcand
	public boolean greaterThan;	// true if numTarget target digits > corresponding digits in max

	public Multiplicand(int d, int n, boolean g)
	{
		digits = d;
		numTarget = n;
		greaterThan = g;
	}
}
