#!/usr/bin/env python3
import sys

b, d, a = sys.stdin.readline().split()
b = int(b)
d = int(d)
a = [int(x) for x in a]
assert(b > 0)

reverses = {}
reverses[1] = [0,1,2,3,4,5,6,7,8,9]
reverses[3] = [0,7,4,1,8,5,2,9,6,3]
reverses[7] = [0,3,6,9,2,5,8,1,4,7]
reverses[9] = [0,9,8,7,6,5,4,3,2,1]

def greater_than_a(val, lena):
  if lena > 10:
    return False
  # print("Checking {} > {}?".format(val, a[:lena]))
  if len(str(val)) < lena:
    # print("NOPE, len")
    return False
  if len(str(val)) > lena:
    # print("YUP, len")
    return True
  # print(val > int("".join([str(s) for s in a[:lena]])))
  return val > int("".join([str(s) for s in a[:lena]]))


def solve_d_zero(b):
  lena = len(a)
  result = 0
  while (b % 10) == 0:
    lena -= 1
    b //= 10
    result += 1
  while (b % 2) == 0:
    if greater_than_a(5 * b, lena):
      return result
    b //= 2
    lena -= 1
    result += 1
  while (b % 5) == 0:
    if greater_than_a(2 * b, lena):
      return result
    b //= 5
    lena -= 1
    result += 1
  while True:
    if greater_than_a(10 * b, lena):
      return result
    lena -= 1
    result += 1

def subtract(base, value):
  index = -1
  for v in value:
    if base[index] == '?':
      return
    base[index] -= v
    if base[index] < 0:
      base[index] += 10
      if base[index - 1] != '?':
        base[index - 1] -= 1
    index -= 1

def add(base, value):
  index = -1
  while value:
    if base[index] == '?':
      return
    base[index] += (value % 10)
    if base[index] >= 10:
      base[index] -= 10
      if base[index - 1] != '?':
        base[index - 1] -= 1
    value //= 10
    index -= 1

def solve_for(target, b, lena):
  current = 0  # This is the digits of the current b * K corresponding to a.
  result = 0  # This is the number of digits of target we matched.
  remainder_overflows = False  # This is true b * K > a on the truncated parts.
  last_b_dig = b % 10
  splits = []
  for dig in range(10):
    vval = dig * b
    split = []
    while vval:
      split.append(vval % 10)
      vval //= 10
    splits.append(split) 
  while True:
    lastdig = target[-1]
    if lastdig == '?':
      return result
    revdig = reverses[last_b_dig][lastdig]
    current += b * revdig
    if greater_than_a(current, lena):
      return result
    if remainder_overflows and current and greater_than_a(current - 1, lena):
      return result
    lena -= 1
    last_current_dig = current % 10
    if last_current_dig > int(a[lena]):
      remainder_overflows = True
    if last_current_dig < int(a[lena]):
      remainder_overflows = False
    # If the last digits are the same, the value stays the same.
    current //= 10
    # print(target, b, lena, "lastdig", lastdig, "revdig", revdig)
    subtract(target, splits[revdig])
    # print(target, b, lena, revdig)
    # assert(target[-1] == 0)
    target.pop()
    result += 1

def solve_for_targets(targets, b, lena):
  best = 0
  for target in targets:
    cand = solve_for(target, b, lena)
    # print("Solving for ", target, len(target), "getting", cand)
    if cand > best:
      best = cand
  return best

def solve_manual(b, d):
  best = 0
  for x in range(1000):
    val = b * x
    if greater_than_a(val, len(a)):
      return best
    v = str(val)
    cand = 0
    pos = len(v) - 1
    while pos >= 0 and v[pos] == str(d):
      pos -= 1
      cand += 1
    if cand > best:
      best = cand
  return best

# This is naive long division.
def divide(target, val):
  res = []
  cur = 0
  for v in target:
    cur *= 10
    cur += v
    div = cur // val
    assert (div < 10)
    if res or div:
      res.append(div)
    cur -= div * val
  return res


def solve():
  global b
  global a
  global d
  origb = b
  origd = d
  origa = a[:]
  choicemap_two = [[0], [0, 5], [0, 25, 50, 75],
                   [0, 125, 250, 375, 500, 625, 750, 875]]
  choicemap_five = [[0], [0, 2, 4, 6, 8]]
  if d == 0:
    return solve_d_zero(b)
  last_b_dig = b % 10
  if last_b_dig == 0:
    return 0
  choices = [0]
  choicelen = 0
  while (last_b_dig % 2) == 0:
    if (d % 2) != 0:
      a = origa
      return solve_manual(origb, origd)
    d //= 2
    b //= 2
    a = divide(a, 2)
    choicelen += 1
    last_b_dig = b % 10
  if choicelen:
    choices = choicemap_two[choicelen]
  else:
    while (last_b_dig % 5) == 0:
      if (d % 5) != 0:
        a = origa
        return solve_manual(origb, origd)
      d //= 5
      b //= 5
      a = divide(a, 5)
      choicelen += 1
      last_b_dig = b % 10
    if choicelen:
      choices = choicemap_two[choicelen]
  targets = []
  # print("WHAT??", choices)
  for choice in choices:
    if not choice:
      target = ['?']
      while len(target) <= len(a) + 1:
        target.append(d)
      targets.append(target)
    else:
      for diff in range(9):
        x = len(a) - diff
        if x >= 0:
          target = ['?']
          for _ in range(min(x, choicelen)):
            target.append(d)
          add(target, choice)
          while len(target) < x + 1:
            target.append(d)
          targets.append(target)
  # print(targets)
  # print(len(targets))
  # print(len(targets[0]))
  return solve_for_targets(targets, b, len(a))

    


print(solve())
