#include "validate.h"
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

const double eps = 1.1e-5;

typedef vector<double> vd;
typedef vector<vd> vvd;

int d, n;
vvd input;

void read_input(istream &in) {
  in >> d >> n;
  input = vvd(n, vd(d + 1));
  for (vd &row: input)
    for (double &x: row)
      in >> x;
}

void read_answer(istream &ans) {
}

vd output;

void read_solution(istream &sol, feedback_function feedback) {
  output = vd(d);
  for (int i = 0; i < d; i++)
    if (!(sol >> output[i]))
      feedback("failed to read coordinate %d from solution\n", i + 1);
}

void check_vector(int i, const vd &v, feedback_function feedback) {
  double distance = 0.0;
  for (int i = 0; i < d; i++)
    distance += (v[i] - output[i]) * (v[i] - output[i]);
  distance = sqrt(distance);
  double error = abs(distance - v[d]);
  if (abs(v[d]) > 1)
    error /= abs(v[d]);
  if (error > eps)
    feedback("distance to vector %d should be %.17f but is %.17f, error %.17f\n", i + 1, v[d], distance, error);
}

void check_solution(feedback_function feedback) {
  for (int i=0 ; i<n ; i++)
    check_vector(i, input[i], feedback);
}

int main(int argc, char **argv) {
  init_io(argc, argv);

  read_input(judge_in);
  read_answer(judge_ans);
  read_solution(author_out, wrong_answer);
  check_solution(wrong_answer);

  /* Check for trailing output. */
  string trash;
  if (author_out >> trash)
    wrong_answer("Trailing output\n");

  accept();
}

