import random
import sys

file_cnt = 0
def next_file0(desc = None):
  global file_cnt
  file_cnt += 1
  if desc != None:
    file_name = "{:02}.desc".format(file_cnt)
    sys.stdout.close()
    sys.stdout = open(file_name, "w")
    print(desc)
  file_name = "{:02}.in".format(file_cnt)
  sys.stdout.close()
  sys.stdout = open(file_name, "w")

def next_file(d, n, s):
  next_file0('d = {}, n = {}: {}'.format(d, n, s))

random.seed(314159265)

mind, maxd = 1, 500 # 1000
minn, maxn = 1, 500 # 1000
minx, maxx = -1000, 1000
mine, maxe = 0, 1000
eps = 1e-6

try:
  xrange
except:
  xrange = range

def random_vector(d, minx, maxx):
  return [ random.uniform(minx, maxx) for _ in range(d) ]

def distance(xs, ys):
  return sum((xs[i] - ys[i]) ** 2 for i in range(len(xs))) ** 0.5

def print_vector(xs, e):
  for x in xs:
    print('{:.17f} '.format(x), end='')
  print('{:.17f}'.format(e))

def scale(xs, ys, f):
  for i in range(len(ys)):
    ys[i] = xs[i] + (ys[i] - xs[i]) * f

def random_input(d, n):
  print('{} {}'.format(d, n))
  v = random_vector(d, minx, maxx)
  for _ in range(n):
    w = random_vector(d, minx, maxx)
    e = distance(v, w)
    f = random.uniform(mine, maxe)
    scale(v, w, f / e)
    print_vector(w, f)

def small_random(k):
  for _ in range(k):
    d = random.randint(mind, maxd//100)
    n = random.randint(minn, maxn//100)
    next_file(d, n, 'random')
    random_input(d, n)

def med_random(k):
  for _ in range(k):
    d = random.randint(mind, maxd//100)
    n = random.randint(maxn//100, maxn//10)
    next_file(d, n, 'random')
    random_input(d, n)
  for _ in range(k):
    d = random.randint(maxd//100, maxd//10)
    n = random.randint(minn, maxn//100)
    next_file(d, n, 'random')
    random_input(d, n)
  for _ in range(k):
    d = random.randint(maxd//100, maxd//10)
    n = random.randint(maxn//100, maxn//10)
    next_file(d, n, 'random')
    random_input(d, n)

def big_random(k):
  for _ in range(k):
    d = random.randint(maxd//100, maxd//10)
    n = random.randint(maxn//10, maxn)
    next_file(d, n, 'random')
    random_input(d, n)
  for _ in range(k):
    d = random.randint(maxd//10, maxd)
    n = random.randint(maxn//100, maxn//10)
    next_file(d, n, 'random')
    random_input(d, n)
  for _ in range(k):
    d = random.randint(maxd//10, maxd)
    n = random.randint(maxn//10, maxn)
    next_file(d, n, 'random')
    random_input(d, n)

def max_random(k):
  for _ in range(k):
    d = maxd
    n = maxn
    next_file(d, n, 'random')
    random_input(d, n)

def all_random(k):
  max_random(k)
  big_random(k)
  med_random(k)
  small_random(k)

def special():
  d = maxd
  n = maxn
  next_file(d, n, 'identical vectors')
  print('{} {}'.format(d, n))
  for i in range(n):
    print_vector([maxx] * d, maxe)
  d = maxd
  n = maxn // 10
  next_file(d, n, 'zero distance')
  print('{} {}'.format(d, n))
  for i in range(n):
    print_vector([minx] * d, 0)
  d = maxd // 10
  n = maxn
  next_file(d, n, 'all zero')
  print('{} {}'.format(d, n))
  for i in range(n):
    print_vector([0] * d, 0)
  d = maxd
  n = maxn
  next_file(d, n, 'collinear vectors')
  print('{} {}'.format(d, n))
  dist = 2 * maxe / (d ** 0.5)
  o = [minx + dist / 2] * d
  for i in range(n):
    v = [minx + dist * i / (n - 1)] * d
    print_vector([minx + dist * i / (n - 1)] * d, distance(v, o))
  d = 1
  n = maxn
  next_file(d, n, 'two solutions')
  print('{} {}'.format(d, n))
  for i in range(n):
    print_vector([minx], maxe / 2)
  d = 1
  n = maxn
  next_file(d, n, 'one solution')
  print('{} {}'.format(d, n))
  for i in range(n):
    print_vector([maxx - i - 2 * eps], maxe - i - 4 * eps)
  d = maxd
  n = 1
  next_file(d, n, 'infinitely many solutions')
  print('{} {}'.format(d, n))
  print_vector([ maxx - i - 2 * i * i * eps for i in range(d) ], maxe - 3 * eps)
  d = maxd
  n = 1
  next_file(d, n, 'one solution')
  print('{} {}'.format(d, n))
  print_vector([ minx + i + 2 * i * i * eps for i in range(d) ], 0)
  d = 1
  n = 1
  next_file(d, n, 'two solutions')
  print('{} {}'.format(d, n))
  print_vector([maxx - 4 * eps], 7 * eps)
  d = 1
  n = 1
  next_file(d, n, 'two solutions near origin')
  print('{} {}'.format(d, n))
  print_vector([0], 3 * eps)
  d = 1
  n = 1
  next_file(d, n, 'one solution')
  print('{} {}'.format(d, n))
  print_vector([3 * eps], 0)
  d = maxd
  n = maxn
  next_file(d, n, 'hypersphere')
  print('{} {}'.format(d, n))
  o = [ minx // 2 + i for i in range(d) ]
  for i in range(n):
    v = [maxx] * d
    v[i] -= 1
    e = distance(o, v)
    scale(o, v, maxe / e)
    print_vector(v, maxe)
  d = 1
  n = 2
  next_file(d, n, 'maximal distance')
  print('{} {}'.format(d, n))
  print_vector([-maxe], maxe)
  print_vector([maxe], maxe)
  d = maxd
  n = maxn
  next_file(d, n, 'orthogonal vectors')
  print('{} {}'.format(d, n))
  for i in range(n):
    v = [-1] * d
    v[i] = -maxe
    print_vector(v, maxe - 1)
  d = maxd - 1
  n = maxn
  next_file(d, n, 'one solution')
  print('{} {}'.format(d, n))
  maxc = int(maxe // (d ** 0.5))
  o = [ ((i ** 2) % maxc) - maxc // 2 - 2 * eps for i in range(d) ]
  es = [ 1 + (i ** 5) % (maxe - maxc - 1) for i in range(d) ]
  print_vector([0] * d, distance([0] * d, o))
  for i in range(n - 1):
    v = o[:]
    v[i] = o[i] + es[i] if i % 2 == 0 else o[i] - es[i]
    print_vector(v, es[i])
  d = maxd
  n = maxn
  next_file(d, n, 'two solutions')
  print('{} {}'.format(d, n))
  maxc = int(maxe // (d ** 0.5))
  o = [ ((i ** 4) % maxc) - maxc // 2 + 2 * eps for i in range(d) ]
  es = [ 1 + (i ** 3) % (maxe - maxc - 1) for i in range(d) ]
  print_vector([0] * d, distance([0] * d, o))
  for i in range(n - 1):
    v = o[:]
    v[i] = o[i] + es[i] if i % 2 == 0 else o[i] - es[i]
    print_vector(v, es[i])
  d = maxd
  n = maxn
  next_file(d, n, 'one solution')
  print('{} {}'.format(d, n))
  maxc = int(maxe // (d ** 0.5))
  o = [ ((i ** 4) % maxc) - maxc // 2 + 2 * eps for i in range(d) ]
  es = [ (i ** 3) % (maxe - maxc) for i in range(d) ]
  print_vector([0] * d, distance([0] * d, o))
  for i in range(n - 1):
    v = o[:]
    v[i] = o[i] + es[i] if i % 2 == 0 else o[i] - es[i]
    print_vector(v, es[i])
  d = maxd
  n = 2
  next_file(d, n, 'one solution')
  print('{} {}'.format(d, n))
  maxc = int(maxe // (d ** 0.5))
  o = [ ((i ** 4) % maxc) - maxc // 2 + 2 * eps for i in range(d) ]
  print_vector([0] * d, distance([0] * d, o))
  print_vector(o, 0)
  d = maxd
  n = 2
  next_file(d, n, 'one solution')
  print('{} {}'.format(d, n))
  maxc = int(maxe // (d ** 0.5))
  o = [ ((i ** 4) % maxc) - maxc // 2 + 2 * eps for i in range(d) ]
  print_vector(o, 0)
  o[3] += 2e-7
  print_vector(o, 2e-7)
  d = maxd
  n = maxn
  next_file(d, n, 'close vectors')
  print('{} {}'.format(d, n))
  o = [ maxx * 6 / 7 - i - i * i * eps for i in range(d) ]
  for i in range(n):
    v = [ o[j] + ((j ** 3 + i ** 2) % 13) * eps for j in range(d) ]
    print_vector(v, distance(v, o))

special()
all_random(2)
#all_random(1200)

sys.stdout.close()
