import math
import random
import sys

file_cnt = 0
def next_file0(desc = None):
  global file_cnt
  file_cnt += 1
  if desc != None:
    file_name = "{:02}.desc".format(file_cnt)
    sys.stdout.close()
    sys.stdout = open(file_name, "w")
    print(desc)
  file_name = "{:02}.in".format(file_cnt)
  sys.stdout.close()
  sys.stdout = open(file_name, "w")

def next_file(d, n, s):
  next_file0('d = {}, n = {}: {}'.format(d, n, s))

random.seed(314159265)

mind, smalld, larged, maxd = 1, 5, 50, 500
minn, smalln, largen, maxn = 1, 5, 50, 500
minx, maxx = -100, 100
# mine, maxe = 0, 5000

try:
  xrange
except:
  xrange = range

def random_vector(d, minx, maxx):
  return [ random.uniform(minx, maxx) for _ in range(d) ]

def distance(xs, ys):
  return math.fsum((xs[i] - ys[i]) ** 2 for i in range(len(xs))) ** 0.5

def print_vector(xs, e):
  for x in xs:
    print('{:.17f} '.format(x), end='')
  print('{:.17f}'.format(e))

def scale(xs, ys, f):
  for i in range(len(ys)):
    ys[i] = xs[i] + (ys[i] - xs[i]) * f

def random_input(d, n):
  print('{} {}'.format(d, n))
  v = random_vector(d, minx, maxx)
  for _ in range(n):
    w = random_vector(d, minx, maxx)
    e = distance(v, w)
    print_vector(w, e)

def small_random(k):
  for _ in range(k):
    d = random.randint(mind, smalld)
    n = random.randint(minn, smalln)
    next_file(d, n, 'random')
    random_input(d, n)

def med_random(k):
  for _ in range(k):
    d = random.randint(mind, smalld)
    n = random.randint(smalln + 1, largen)
    next_file(d, n, 'random')
    random_input(d, n)
  for _ in range(k):
    d = random.randint(smalld + 1, larged)
    n = random.randint(minn, smalln)
    next_file(d, n, 'random')
    random_input(d, n)
  for _ in range(k):
    d = random.randint(smalld + 1, larged)
    n = random.randint(smalln + 1, largen)
    next_file(d, n, 'random')
    random_input(d, n)

def mix_random(k):
  for _ in range(k):
    d = random.randint(mind, smalld)
    n = random.randint(largen + 1, maxn)
    next_file(d, n, 'random')
    random_input(d, n)
  for _ in range(k):
    d = random.randint(larged + 1, maxd)
    n = random.randint(minn, smalln)
    next_file(d, n, 'random')
    random_input(d, n)

def large_random(k):
  for _ in range(k):
    d = random.randint(smalld + 1, larged)
    n = random.randint(largen + 1, maxn)
    next_file(d, n, 'random')
    random_input(d, n)
  for _ in range(k):
    d = random.randint(larged + 1, maxd)
    n = random.randint(smalln + 1, largen)
    next_file(d, n, 'random')
    random_input(d, n)
  for _ in range(k):
    d = random.randint(larged + 1, maxd)
    n = random.randint(largen + 1, maxn)
    next_file(d, n, 'random')
    random_input(d, n)

def max_random(k):
  for _ in range(k):
    d = maxd
    n = maxn
    next_file(d, n, 'random')
    random_input(d, n)

def all_random(k):
  max_random(k)
  large_random(k)
  mix_random(k)
  med_random(k)
  small_random(k)

def special_random(k, d1, d2, n1, n2):
  for _ in range(k):
    d = random.randint(d1, d2);
    n = random.randint(n1, n2);
    next_file(d, n, 'random')
    random_input(d, n)

all_random(5)
#special_random(1000, 2, 2, 1, 15);
#special_random(1000, 5, 5, 1, 15);

sys.stdout.close()
