#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int N, K;
    cin >> N >> K;
    vector<uint32_t> h(N);
    for (int i = 0; i < K; i++)
    {
        char c;
        int x1, x2;
        cin >> c >> x1 >> x2;
        x1--;
        x2--;
        switch (c)
        {
        case 'R':
        case 'D':
            {
                int d = (c == 'R') ? 1 : -1;
                for (int j = x1; j <= x2; j++)
                    h[j] += d;
            }
            break;
        case 'H':
        case 'V':
            {
                int m1 = (x1 + x2) / 2;
                int d = (c == 'H') ? 1 : -1;
                for (int j = x1; j <= m1; j++)
                    h[j] += (j - x1 + 1) * d;
                for (int j = m1 + 1; j <= x2; j++)
                    h[j] += (x2 - j + 1) * d;
            }
            break;
        }
    }

    // Exploit fact that maximum difference between adjacent heights is
    // less than 2^31.
    ll last = 0;
    for (int i = 0; i < N; i++)
    {
        ll cur = h[i];
        while (cur < last - 2 * K)
            cur += 1ULL << 32;
        while (cur > last + 2 * K)
            cur -= 1ULL << 32;
        cout << cur << '\n';
        last = cur;
    }
    return 0;
}
